unit ProcFunc;

interface

uses Konstanten, SysUtils, ShellAPI, WinProcs, Controls, stdctrls, Messages,
     Clipbrd, classes;
{---- Neue Typen -------------------------------------------------------------}
type
  Str255 = string[255];

{---- Funktionen -------------------------------------------------------------}
function CutPath(LPath : String) : String;
function OwnDir : String;

function GetCountry: byte;

function ExecErr(const ErrNum, country: word): Str255;
                { Returns a string corresponding to the    }
                { errocode of WinExec()                    }
                { with country = English: English messages }
                { with country = German: German messages   }

function ExecuteDataFile(const Filename: string;
                         var   Exec    : string): boolean;
function ExecConsoleApp(CommandLine: String;
                       OutputWindow: hWnd): Integer;

function IsEditControl(Handle : HWnd): Boolean;
function HasText(Control : TWinControl): Boolean;
function CanPaste(Control : TWinControl): Boolean;

// HTML Funktionen
function GetCRLFCount(Value: string): integer;
function MaskHTML(Value: integer): string;

// String Funktionen
function ANSI2OEM(Const s : string) : string;
function OEM2ANSI(Const s : string) : string;
function delQuot(s: string): string;
function delFLQuot(s: string): string;
function isPipe (Const s : String) : Boolean;
function StartStr(Const s : String) : String;
function EndStr(Const s :   String) : String;
function TileFilter(s: string): TStringList;
function BacksToSlash(Const s : String) : String;
function SlashToBacks(Const s : String) : String;
function DelTag(var ml: boolean; s : String) : string;
function GetToken(aString: String; SepChar: Char; TokenNum: integer): String;
function NumToken(aString: String; SepChar: Char): integer;
function StrBedingung(Bedingung: Boolean; S1, S2: String): String;
function GetPerlLine(aString: String): Integer;

// Datei Funktionen
function ExtractFileExtN(Const s : String) : String;
function ExtractNameNoExt(Const s : String) : String;
function CheckBSLH(Const s: String) : String;
function URLToPath(Const url: String): String;
function cleanLocation(url: String): String;

// String Proceduren
procedure delFLQuotP(var s: String);
procedure StrChange(var inStr: String; oldStr, newStr: String);
procedure RetStrChange(var inStr: String; newStr, oldStr: String);
procedure ConvertCRLF2HTMLBR(var inStr: String);
procedure ConvertHTMLBR2CRLF(var inStr: String);
procedure GetOnlyNumbers(var s: String);
procedure GetBot(var sIn, sOut, sBev, sAft: String);

implementation

function CutPath(LPath : String) : String;
var
  Count : Byte;
  Drive : String;
  NPath : String;
begin
  Count := 0;
  repeat
    Count := Count + 1;
  until LPath[Count] = '\';
  Drive := Copy(LPath,1, Count);
  Count := Length(LPath);
  repeat
    Count := Count - 1;
  until LPath[Count] = '\';
  NPath := Copy(LPath,Count, Length(LPath)-(Count-1));
  if Length(NPath) = 0 then
    Result := Drive
  else
    Result := Drive + '...' + NPath;
end;

function OwnDir : String;
var
  Path: String;
begin
  Path := ExpandFileName(ParamStr(0)); { Path + name }
  Path := ExtractFileDir(Path);
  OwnDir := Path;
end;

function GetCountry: byte;
{ THIS IS A DOS ROUTINE, NOT TESTED FROM WITHIN WINDOWS. }
{ IT RETURNS THE COUNTRY CODE 001 (US), 49 (GER) ...     }
{ AS DEFINED WITH COUNTRY=... IN THE CONFIG.SYS FILE     }
{ AND WILL NOT WORK WITH DELPHI32!                       }
{$IFNDEF Win32}
type
  tBuffer = RECORD (* DOS-Puffer with country informat. *)
    DateFormat: WORD;  (* valid only for DOS 3.0 ++   ! *)
    Currency  : ARRAY[0..4] OF CHAR;(* Currency         *)
    thousand  : CHAR;             (* thousands . or ,   *)
    dummy1    : BYTE;             (* a Zero byte        *)
    dezimal   : CHAR;             (* Dezimal-Zeichen    *)
    dummy2    : BYTE;             (* a Zero byte        *)
    date      : CHAR;             (* date char          *)
    dummy3    : BYTE;             (* a Zero byte        *)
    time      : CHAR;             (* Time char          *)
    dummy4    : BYTE;             (* a Zero byte        *)
    Curr_Form : BYTE; (* BITSET *)(* format of currency *)
    exact     : BYTE; (* chars behind the currency comma*)
    Time_Form : BYTE; (* BITSET *)(* time format        *)
    Rout_Offs : WORD; (* Offset DOS charset table       *)
    Rout_Seg  : WORD; (* Segment DOS charset table      *)
    reserved  : ARRAY[0..11] OF BYTE; (* reserv. area   *)
  end;
var
  vBuffer : tBuffer;
  Temp    : BYTE;
begin
  asm
    MOV AX, 3800h
    MOV BX, Seg(vBuffer)
    MOV DS, BX
    MOV DX, Offset vBuffer
    CALL Dos3Call  {INT 21h }
    MOV Temp, BL
  end;
  GetCountry := Temp;
end;
{$ELSE}
begin
  GetCountry := 049;
end;  
{$ENDIF}

function ExecErr(const ErrNum, country: word): Str255;
var
  ErrorMsg : Str255;
begin
  case country of
    langSwiss,
    langAustrian,
    langGerman: 
    begin
      case ErrNum of
        0: ErrorMsg := 'Zu wenig Speicher';
        2: ErrorMsg := 'Auszufhrendes Programm nicht '
                     + 'gefunden';
        3: ErrorMsg := 'Pfad zum Programm nicht gefunden';
        5: ErrorMsg := 'Zugriffsfehler/Netzwerk-'
                     + 'Zugriffsverletzung';
        6: ErrorMsg := 'Windows-Speicherfehler';
        8: ErrorMsg := 'Zu wenig Speicher fr Anwendung';
       10: ErrorMsg := 'Falsche Windows-Version';
       11: ErrorMsg := 'Ungltige EXE-Datei';
       12: ErrorMsg := 'Programm fr anderes Betriebssystem';
       13: ErrorMsg := 'DOS-4.0-Anwendung';
       14: ErrorMsg := 'Unbekanntes EXE-Format';
       15: ErrorMsg := 'Windows 1.x/2.x-Anwendung';
       16: ErrorMsg := 'Programm bereits aktiv';
       19: ErrorMsg := 'Komprimierte Datei';
       20: ErrorMsg := 'DLL-Fehler';
       21: ErrorMsg := 'Anwendung bentigt '
                     + 'Win32-Extension';
       1,4,7,9,17,
       18,22..32: ErrorMsg := 'Unbekannter Fehler (Nummer '
                              + IntToStr(ErrNum) + ')';

      else        
        ErrorMsg := 'Kein Fehler aufgetreten';
      end; { CASE ErrNum }
    end { langGerman, langAustrian, langSwiss }
    { *** Insert other Languages here *** }
    else  { English, Intl. Version }
    case ErrNum of
        0: ErrorMsg := 'System out of Memory';
        2: ErrorMsg := 'File to Execute not found';
        3: ErrorMsg := 'Path to Program not found';
        5: ErrorMsg := 'Link or Network Error';
        6: ErrorMsg := 'Windows Memory Error';
        8: ErrorMsg := 'Not Enough Memory';
       10: ErrorMsg := 'Incorrect Windows version';
       11: ErrorMsg := 'Invalid Executable';
       12: ErrorMsg := 'Application designed for other OS';
       13: ErrorMsg := 'DOS 4.0 Application';
       14: ErrorMsg := 'Unknown type of executable';
       15: ErrorMsg := 'Attempt to load Real Mode Application';
       16: ErrorMsg := 'Program already loaded';
       19: ErrorMsg := 'Compressed executable file, unpack it first';
       20: ErrorMsg := 'Invalid dynamic link library';
       21: ErrorMsg := 'Application requires 32 bit extension ';
       1,4,7,9,17,
       18,22..32: ErrorMsg := 'Unexpected Error '
                             + IntToStr(ErrNum)
                             + ' occured';
    else        
      ErrorMsg := 'No error occured';
    end;{ CASE ErrNum }
  end; { ELSE }
  ExecErr := ErrorMsg;
end;

function ExecuteDataFile(const Filename: string; var Exec: string): boolean;
var
  Fle, Path : String;
  Buffer    : ARRAY[1..250] OF CHAR;
  i, j      : INTEGER;
  pEx       : pChar;
  ExResult  : INTEGER;
  Extension : STRING;
BEGIN
  Extension := AnsiUpperCase(ExtractFileExt(FileName));
  IF (Extension = '.EXE') OR (Extension = '.COM') OR
     (Extension = '.PIF') OR (Extension = '.BAT') OR
     (Extension = '.SCR') then
    Exec := ExpandFileName(FileName)
  ELSE 
  BEGIN
    Fle         := ExtractFileName(FileName) + #0;
    Path        := ExtractFilePath(FileName) + #0;
    FillChar(Buffer, SizeOf(Buffer), ' ');
    Buffer[250] := #0;
    result      := true;
    i           := FindExecutable(@Fle[1],
                                  @Path[1],
                                  @Buffer);
    IF i <= 32 THEN BEGIN
      Exec   := '-- nicht verknpft --';
      result := FALSE;
      Exit;
    END;
    Exec := Buffer;
    WHILE Exec[Length(Exec)] = #0  DO
      Delete(Exec, Length(Exec), 1);
    WHILE Exec[Length(Exec)] = ' ' DO
      Delete(Exec, Length(Exec), 1);
    FOR i := 1 TO Length(Exec) - 2 DO
      IF Exec[i] = #0 THEN Exec[i] := ' ';
    i := Pos('.EXE', Exec);
    j := Length(Exec) - 3;
    IF i = j THEN
      Exec := Exec + ' ' + ExpandFileName(FileName);
  END;
  pEx := StrAlloc(Length(Exec) + 1);
  StrPCopy(pEx, Exec);
  ExResult := WinExec(pEx, SW_ShowNormal);
  StrDispose(pEx);
  Result := ExResult > 32;
end;

function ExecConsoleApp(CommandLine: String;
                       OutputWindow: hWnd): Integer;
const
  BufSize = $4000;
  {for this simple example, the pipe should be able to
  hold the entire output of the console app.
  Predictably, this call hangs if CommandLine points to a
  Win32 GUI app. Tested with Win32 and MS-DOS console apps}
var
  StartupInfo : TStartupInfo;
  ProcessInfo : TProcessInformation;
  WriteHandle, ReadHandle : THandle;
  ReadBuf : array[0..BufSize] of Char;
  BytesRead : Integer;

begin
  FillChar(StartupInfo, SizeOf(StartupInfo), 0);
  FillChar(ReadBuf, SizeOf(ReadBuf), 0);
  CreatePipe(ReadHandle, WriteHandle, nil, BufSize);
  with StartupInfo do
  begin
    cb := SizeOf(StartupInfo);
    dwFlags    := STARTF_USESHOWWINDOW or
                  STARTF_USESTDHANDLES;
    hStdOutput := WriteHandle;
    hStdError  := WriteHandle;
    wShowWindow:= SW_HIDE;
  end;
  if not CreateProcess(nil, PChar(CommandLine), nil, nil,
     false, DETACHED_PROCESS or NORMAL_PRIORITY_CLASS,
     nil, nil, StartupInfo, ProcessInfo) then
  begin
    Result:= -1
  end else
  begin
    WaitForSingleObject(ProcessInfo.hProcess, INFINITE);
    {if you want to do a running update of the output of
    the console app, you would not block here. Instead you
    could loop while GetExitCodeProcess returned STILL_ACTIVE
    all the while calling ReadFile on the pipe. Overlapped IO
    would be nice, but I am not sure it would work on an
    anonymous pipe. I have tried polling the pipe (works OK)
    but not overlapped IO. MGL}
    ReadFile(ReadHandle, ReadBuf, BufSize, BytesRead, nil);
    SetWindowText(OutputWindow, ReadBuf);
    GetExitCodeProcess(ProcessInfo.hProcess, Result);
    CloseHandle(ProcessInfo.hProcess);
    CloseHandle(ProcessInfo.hThread)
  end;
  CloseHandle(WriteHandle)
end;

function IsEditControl(Handle : HWnd): Boolean;
var
  szName : array[0..4] of Char;
begin
  if (Handle = 0) then
    Result := False

  else begin
    GetClassName(Handle, szName, SizeOf(szName));
    Result := (StrIComp(szName, 'edit') = 0);
  end;
end;

function HasText(Control : TWinControl): Boolean;
var
  Handle : HWnd;
  Select : LongInt;
  First  : Word;
  Last   : Word;

begin
  if (Control is TCustomEdit) then
    Result := (TEdit(Control).SelLength > 0)

  { this is here basically to handle combo box edit fields }
  else begin
    Handle := GetFocus;

    if IsEditControl(Handle) then begin
      Select := SendMessage(Handle, EM_GETSEL, 0, 0);
      First  := LOWORD(Select);
      Last   := HIWORD(Select);
      Result := (First <> Last);
    end

    else
      Result := False;
  end
end;

function CanPaste(Control : TWinControl): Boolean;
begin
  if (Control is TCustomEdit) or IsEditControl(GetFocus) then
    Result := ClipBoard.HasFormat(CF_TEXT)
  else
    Result := False;
end;

// HTML Funktionen
function GetCRLFCount(Value: string): integer;
var
  Zaehler : integer;
begin
  Zaehler := -1;
  while Pos(SCRLF, Value) > 0 do
  begin
    Delete(Value, Pos(SCRLF, Value), length(SCRLF)+1);
    inc(Zaehler); 
  end; 
  GetCRLFCount := Zaehler;
end;

function MaskHTML(Value: integer): string;
var
  sResult : string;
begin
  case Value of
    160 : sResult := 'nbsp';
    161 : sResult := 'iexcl';
    162 : sResult := 'cent';
    163 : sResult := 'pound';
    164 : sResult := 'curren';
    165 : sResult := 'yen';
    166 : sResult := 'brvbar';
    167 : sResult := 'sect';
    168 : sResult := 'uml';
    169 : sResult := 'copy';
    170 : sResult := 'ordf';
    171 : sResult := 'laquo';
    172 : sResult := 'not';
    173 : sResult := 'shy';
    174 : sResult := 'reg';
    175 : sResult := 'macr';
    176 : sResult := 'deg';
    177 : sResult := 'plusmn';
    178 : sResult := 'sup2';
    179 : sResult := 'sup3';
    180 : sResult := 'acute';
    181 : sResult := 'micro';
    182 : sResult := 'para';
    183 : sResult := 'middot';
    184 : sResult := 'cedil';
    185 : sResult := 'sup1';
    186 : sResult := 'ordm';
    187 : sResult := 'raquo';
    188 : sResult := 'frac14';
    189 : sResult := 'frac12';
    190 : sResult := 'frac34';
    191 : sResult := 'iquest';
    192 : sResult := 'Agrave';
    193 : sResult := 'Aacute';
    194 : sResult := 'Acirc';
    195 : sResult := 'Atilde';
    196 : sResult := 'Auml';
    197 : sResult := 'Aring';
    198 : sResult := 'AElig';
    199 : sResult := 'Ccedil';
    200 : sResult := 'Egrave';
    201 : sResult := 'Eacute';
    202 : sResult := 'Ecirc';
    203 : sResult := 'Euml';
    204 : sResult := 'Igrave';
    205 : sResult := 'Iacute';
    206 : sResult := 'Icirc';
    207 : sResult := 'Iuml';
    208 : sResult := 'ETH';
    209 : sResult := 'Ntilde';
    210 : sResult := 'Ograve';
    211 : sResult := 'Oacute';
    212 : sResult := 'Ocirc';
    213 : sResult := 'Otilde';
    214 : sResult := 'Ouml';
    215 : sResult := 'times';
    216 : sResult := 'Oslash';
    217 : sResult := 'Ugrave';
    218 : sResult := 'Uacute';
    219 : sResult := 'Ucirc';
    220 : sResult := 'Uuml';
    221 : sResult := 'Yacute';
    222 : sResult := 'THORN';
    223 : sResult := 'szlig';
    224 : sResult := 'agrave';
    225 : sResult := 'aacute';
    226 : sResult := 'acirc';
    227 : sResult := 'atilde';
    228 : sResult := 'auml';
    229 : sResult := 'aring';
    230 : sResult := 'aelig';
    231 : sResult := 'ccedil';
    232 : sResult := 'egrave';
    233 : sResult := 'eacute';
    234 : sResult := 'ecirc';
    235 : sResult := 'euml';
    236 : sResult := 'igrave';
    237 : sResult := 'iacute';
    238 : sResult := 'icirc';
    239 : sResult := 'iuml';
    240 : sResult := 'eth';
    241 : sResult := 'ntilde';
    242 : sResult := 'ograve';
    243 : sResult := 'oacute';
    244 : sResult := 'ocirc';
    245 : sResult := 'otilde';
    246 : sResult := 'ouml';
    247 : sResult := 'divide';
    248 : sResult := 'oslash';
    249 : sResult := 'ugrave';
    250 : sResult := 'uacute';
    251 : sResult := 'ucirc';
    252 : sResult := 'uuml';
    253 : sResult := 'yacute';
    254 : sResult := 'thorn';
    255 : sResult := 'yuml';
  end;
  MaskHTML := '&' + sResult + ';';
end;

function ANSI2OEM(CONST s : STRING) : STRING;
var
  t : STRING;
  p : pChar;
begin
  p := StrAlloc(Length(s) + 1);
  StrPCopy(p, s);
  ANSItoOEM(p, p);
  t := StrPas(p);
  StrDispose(p);
  ANSI2OEM := t;
end;

function OEM2ANSI(CONST s : STRING) : STRING;
var
  t : STRING;
  p : pChar;
begin
  p := StrAlloc(Length(s) +1);
  StrPCopy(p, s);
  OEMtoANSI(p, p);
  t := StrPas(p);
  StrDispose(p);
  OEM2ANSI := t;
end;

function delQuot(s: string): string;
var
  sReturn : string;
begin
  sReturn := s;
  while Pos('"', sReturn) > 0 do
    Delete(sReturn, Pos('"',sReturn), 1);
  delQuot := sReturn;
end;

function delFLQuot(s: string): string;
var
  sReturn : string;
begin
  sReturn := s;
  if Pos('"', sReturn) > 0 then Delete(sReturn, Pos('"', s), 1);
  if Pos('"', sReturn) > 0 then Delete(sReturn, Pos('"', s), 1);
  delFLQuot := sReturn;
end;

function isPipe(const s: String) : Boolean;
var
  s1     : String;
  isBool : Boolean;
begin
  S1 := s;
  if Pos('|', s1) = 0 then
   isBool := false
  else
   isBool := true;
  isPipe := isBool;
end;

function StartStr(const s : String) : String;
var
  s1 : String;
begin
  s1 := s;
  delete(S1, Pos('|', s1),Length(s1));
  StartStr := s1;
end;

function EndStr(const s : String) : String;
var
  s1 : String;
begin
  s1 := s;
  while Pos('|', s1) > 0 do
    Delete(s1, 1, 1);
  endStr:=S1;
end;

function TileFilter(s: string): TStringList;
var
  tempStr : String;
begin
  tempStr := s;
  Result  := TStringList.Create;
  try
    while Pos('|', s) > 0 do
    begin
      tempStr := StartStr(s);
      Result.Add(tempStr);
      Delete(s, 1, Length(tempStr) + 1);
    end;
    Result.Add(s); // letzte Eerweiterung in Liste Einfgen
  except
    Result.Free;
  end;
end;

function GetToken(aString: String; SepChar: Char; TokenNum: integer): String;
var
  Token  : String;
  StrLen : Integer;
  TNum   : integer;
  TEnd   : integer;
begin
  StrLen := Length(aString);
  TNum   := 1;
  TEnd   := StrLen;
  while ((TNum <= TokenNum) and (TEnd <> 0)) do
  begin
    TEnd := Pos(SepChar, aString);
    if TEnd <> 0 then
    begin
      Token := Copy(aString, 1, TEnd -1);
      Delete(aString, 1, TEnd);
      inc(TNum);
    end
    else
      Token := aString;
  end;
  if TNum >= TokenNum then
    Result := Token
  else
    Result := '';
end;

function NumToken(aString: String; SepChar: Char): integer;
var
  RChar   : Char;
  StrLen  : Integer;
  TNum    : Integer;
  TEnd    : Integer;
begin
  if SepChar = '#' then
    RChar := '*'
  else
    RChar := '#';
  StrLen := length(aString);
  TNum   := 0;
  TEnd   := StrLen;
  while TEnd <> 0 do
  begin
    Inc(TNum);
    TEnd := Pos(SepChar, aString);
    if TEnd <> 0 then
      aString[TEnd] := rChar;
  end;
  Result := TNum;
end;

function GetPerlLine(aString: String): Integer;
var
  i : integer;
  s1: String;
begin
  s1 := aString;
  GetPerlLine := -1;
  if Pos('line', s1) > 0 then
  begin
    i := Pos('line', s1);
    Delete(s1, 1,  i + 4);
    GetOnlyNumbers(s1);
    s1 := trim(s1);
    if s1 <> '' then
      GetPerlLine := StrToInt(s1);
  end;
end;

function StrBedingung(Bedingung: Boolean; S1, S2: String): String;
begin
  Result := '';
  if Bedingung then
    Result := S1
  else
    Result := S2;
end;

function BacksToSlash(Const s : String) : String;
var
  s1 : String;
  i  : integer;
begin
  s1 := s;
  for i := 1 to Length(s1) do
    if s1[i] = '\' then s1[i]:='/';
  BacksToSlash := s1;
end;

function SlashToBacks(Const s : String) : String;
var
  s1 : String;
  i  : integer;
begin
  s1 := s;
  for i := 1 to Length(s1) do
    if s1[i] = '/' then s1[i]:='\';
  SlashToBacks := s1;
end;

//******************* CheckBSLH *******************************
function CheckBSLH(Const s: String) : String;
begin
  if s[length(s) -1] = '\' then
    CheckBSLH := s
  else
    CheckBSLH := s + '\';
end;

function URLToPath(Const url: String): String;
var
  i     : integer;
  sTemp : String;
begin
  if Pos('file:', url) = 1 then
    sTemp := Copy(url, Length ('file:') + 4, Length (url))
  else
    if Pos ('http:', url) = 1 then
      sTemp := Copy(url, Length ('http:') + 3, Length (url))
    else
      sTemp := url;
  URLToPath := SlashToBacks(sTemp);
end;

function cleanLocation(url: String): String;
var
  i : Integer;
begin
  i := pos ('%', url);
  while i > 0 do
  begin
    Delete(url, i, 3);
    Insert(' ', url, i);
    i := Pos('%', url);
  end;
  cleanLocation := url;
end;

//******************* ExtractFileExtN *************************
function ExtractFileExtN(Const s :   String) : String;
var
  s1 : String;
begin
  s1 := s;
  while Pos('.', s1) > 0 do
    Delete(s1, 1, 1);
  ExtractFileExtN := S1;
end;

function ExtractNameNoExt(Const s : String) : String;
var
  s1 : String;
begin
  s1 := s;
  Delete(s1, Pos('.', s1), length(s1)+1);
  ExtractNameNoExt := s1;
end;

function DelTag(var ml: boolean; s : String) : string;
var
  s1 : String;
  cs : integer;
  ce : integer;
label
  nochmal;
begin
  s1 := s;
  nochmal:
  if ml then
    cs := 1;
  if Pos('<', s1) > 0 then
  begin
    cs := Pos('<', s1);
    ml := False;
  end;
  ce := Pos('>', s1);
  if cs > 0 then
  begin
    if ce = 0 then
    begin
      ml := true;
      ce := Length(s1);
    end
    else
      ml := false;
    Delete(S1, cs, ce-cs+1);
  end;
  if Pos('<', s1) > 0 then goto nochmal;
  DelTag := s1;
end;

//******************* delFLQuotP *************************
procedure delFLQuotP(var s: String);
begin
  if Pos('"', s) > 0 then Delete(s, Pos('"', s), 1);
  if Pos('"', s) > 0 then Delete(s, Pos('"', s), 1);
end;

procedure StrChange(var inStr: String; oldStr, newStr: String);
var
  place : integer;
begin
  Repeat Place := pos(oldStr, inStr);
    if place > 0 then begin
      Delete(inStr,place,length(oldStr));
      Insert(newStr, inStr, Place);
    end;
  until place = 0;
end;

procedure RetStrChange(var inStr: String; newStr, oldStr: String);
var
  place : integer;
begin
  Repeat Place := pos(oldStr, inStr);
    if place > 0 then begin
      Delete(inStr,place,length(oldStr));
      Insert(newStr, inStr, Place);
    end;
  until place = 0;
end;

procedure ConvertCRLF2HTMLBR(var inStr: String);
var
  place : integer;
  i     : integer;
  tstr  : string;
begin
  tstr := '<br>';
  Repeat Place := pos(CR, inStr);
    if place > 0 then begin
      Delete(inStr,place,length(CR));
      Insert(tstr+'H!f~', inStr, Place);
    end;
  until (place = 0);
  Repeat Place := pos('H!f~', inStr);
    if place > 0 then begin
      Delete(inStr,place,length('H!f~'));
      Insert(CR, inStr, Place);
    end;
  until (place = 0);
end;

procedure ConvertHTMLBR2CRLF(var inStr: String);
var
  place : integer;
begin
  Repeat Place := pos('<br>', inStr);
    if place > 0 then begin
      Delete(inStr,place,length('<br>'));
      Insert(CRLF, inStr, Place);
    end;
  until place = 0;
  Repeat Place := pos('<BR>', inStr);
    if place > 0 then begin
      Delete(inStr,place,length('<BR>'));
      Insert(CRLF, inStr, Place);
    end;
  until place = 0;
end;

procedure GetOnlyNumbers(var s: String);
var
  i  : integer;
begin
  for i := 0 to length(s) do
    if ((ord(s[i]) < 48) or (ord(s[i]) > 57)) and (ord(s[i]) <> 0) then
      s[i] := ' ';
  trim(s);
end;

procedure GetBot(var sIn, sOut, sBev, sAft: String);
var
  index : integer;
begin
  sBev := Copy(sIn, 1, Pos('[bot', AnsiLowerCase(sIn)) - 1);
  sAft := Copy(sIn, Pos('[/bot]', AnsiLowerCase(sIn)) + 6, length(sIn));
  sOut := copy(sIn, Pos('[bot', AnsiLowerCase(sIn)) - 4,Pos('[/bot]', AnsiLowerCase(sIn)) + 6);
end;

end.
