unit WFDlgOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls, Buttons, WFTools, LibXmlParser;

type
  TWFFOptions = class(TForm)
    PageControl1: TPageControl;
    Panel1: TPanel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    lvSelectModes: TListView;
    btnAdd: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    btnEdit: TBitBtn;
    btnDelete: TBitBtn;
    btnUp: TSpeedButton;
    btnDown: TSpeedButton;
    TabSheet3: TTabSheet;
    lbTexture: TListBox;
    btnAddTexture: TBitBtn;
    btnEditTexture: TBitBtn;
    btnDeleteTexture: TBitBtn;
    btnTextureUp: TSpeedButton;
    btnTextureDown: TSpeedButton;
    Image1: TImage;
    cbTextureLists: TComboBox;
    Label1: TLabel;
    btnAddList: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnAddClick(Sender: TObject);
    procedure lvSelectModesSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure btnEditClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnUpClick(Sender: TObject);
    procedure btnDownClick(Sender: TObject);
    procedure lbTextureClick(Sender: TObject);
    procedure btnTextureUpClick(Sender: TObject);
    procedure btnTextureDownClick(Sender: TObject);
    procedure btnAddTextureClick(Sender: TObject);
    procedure btnEditTextureClick(Sender: TObject);
    procedure btnDeleteTextureClick(Sender: TObject);
    procedure cbTextureListsChange(Sender: TObject);
    procedure btnAddListClick(Sender: TObject);
  private
    { Private declarations }
    procedure loadTextureList(FileName : String);
  public
    { Public declarations }
  end;

var
  WFFOptions: TWFFOptions;

function LoadTexture(const TileID: word; var bitmap: TBitmap):boolean;
function LoadArt(const TileID: word; var bitmap: TBitmap):boolean;

implementation

uses WFDlgSelectMode, WFMapEdit, WFDlgAddTile, Main;

{$R *.dfm}
// Temp hier lassen!
function LoadTexture(const TileID: word; var Bitmap: TBitmap):boolean;
var
  TexIdxFile: file of byte;
  TexMapsFile: file of byte;
  TexturePointer: TTexturePointer;
  TextureBuffer: TTextureBuffer;
  SideLength, X, Y: integer;
  P: PByteArray;
begin
  //if (not FileNamesCorrect) or (TileID >= 16382) then
  if (not FileNamesCorrect) or (TileID >= 4096) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(TexIdxFile, WFMapEditForm.UOPathEdit.Text+'\texidx.mul');
  Reset(TexIdxFile);
  Seek(TexIdxFile, TileID*12);
  BlockRead(TexIdxFile, TexturePointer, SizeOf(TTexturePointer));
  CloseFile(TexIdxFile);
  case TexturePointer.Length of
    $2000: SideLength := 64;
    $8000: SideLength := 128;
  else
    Result := False;
    Exit;
  end;
  AssignFile(TexMapsFile, WFMapEditForm.UOPathEdit.Text+'\texmaps.mul');
  Reset(TexMapsFile);
  Seek(TexMapsFile, TexturePointer.Start);
  BlockRead(TexMapsFile, TextureBuffer, TexturePointer.Length);
  CloseFile(TexMapsFile);
  // Reading file done
  Bitmap.Width := SideLength;
  Bitmap.Height := SideLength;
  Bitmap.PixelFormat := pf15bit;
  {$R-}
  begin
    for Y := 0 to SideLength-1 do
    begin
      P := Bitmap.ScanLine[Y];
      for X := 0 to SideLength-1 do
      begin
        P[X*2{15Bit}  ] := TextureBuffer[(Y*SideLength+X)*2  ];
        P[X*2{15Bit}+1] := TextureBuffer[(Y*SideLength+X)*2+1];
      end;
    end;
  end;
  {$R+}
  Result := True;
end;

//hoenie
function LoadArt(const TileID: word; var Bitmap: TBitmap):boolean;
var
  ArtIdxFile: file of byte;
  ArtFile: file of byte;
  ArtPointer: TArtPointer;
  TempArray: array[0..16382] of byte;
  // TempArray: array[0..2047] of byte;
  TempMap: array[0..45, 0..45, 0..1] of byte;
  i, X, Y, XStart, YStart: integer;
  P: PByteArray;
begin
  Result:=False;
	case tileid of
   	$0007,$0008:exit;
   end;
  if (not FileNamesCorrect) or (TileID >= 16382) then
  //if (not FileNamesCorrect) or (TileID >= 4096) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(ArtIdxFile, WFMapEditForm.UOPathEdit.Text+'\artidx.mul');
  Reset(ArtIdxFile);
  Seek(ArtIdxFile, TileID*12);
  BlockRead(ArtIdxFile, ArtPointer, SizeOf(TArtPointer));
  CloseFile(ArtIdxFile);
  if (ArtPointer.Start = $FFFFFFFF) or
    not (ArtPointer.Length = 2048) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(ArtFile, WFMapEditForm.UOPathEdit.Text+'\art.mul');
  Reset(ArtFile);
  Seek(ArtFile, ArtPointer.Start);
  BlockRead(ArtFile, TempArray, ArtPointer.Length-4);
  CloseFile(ArtFile);
  // Reading file done
  Bitmap.Width := 45;
  Bitmap.Height := 45;
  Bitmap.PixelFormat := pf15bit;
  Bitmap.Canvas.Brush.Color := clBlack;
  Bitmap.Canvas.FillRect(Bitmap.Canvas.ClipRect);

  i := 0;
  XStart := 0;
  YStart := 1;

  ZeroMemory(Addr(TempMap), SizeOf(TempMap));

  {$R-}
  while True do
  begin
    X := XStart;
    Y := YStart;
    while (X <= 44) and (Y >= 0) do
    begin
      TempMap[X, Y][0] := TempArray[i];
      TempMap[X, Y][1] := TempArray[i+1];
      TempMap[X+1, Y][0] := TempArray[i];
      TempMap[X+1, Y][1] := TempArray[i+1];
      TempMap[X, Y+1][0] := TempArray[i];
      TempMap[X, Y+1][1] := TempArray[i+1];
      Inc(i, 2);
      Inc(X, 1);
      Dec(Y, 1);
    end;
    if YStart < 43 then
    begin
      Inc(YStart, 2);
    end
    else if YStart = 43 then
    begin
      Inc(YStart, 1);
      Inc(XStart, 1);
    end
    else // YStart = 44
    begin
      Inc(XStart, 2);
    end;
    if XStart > 43 then Break;
  end;

  begin
    for Y := 0 to 44 do
    begin
      P := Bitmap.ScanLine[Y];
      for X := 0 to 44 do
      begin
        P[X*2{15Bit}  ] := TempMap[X, Y][0];
        P[X*2{15Bit}+1] := TempMap[X, Y][1];
      end;
    end;
  end;
  {$R+}

  Result := True;
end;

// Temp hier lassen!

procedure TWFFOptions.loadTextureList(FileName : String);
var
  sTexture : TStringList;
  ahex : string;
  aint, i : integer;
begin
  sTexture := TStringList.Create;
  sTexture.LoadFromFile(MainForm.Appath+'Textures\'+FileName);
  for i := 0 to sTexture.Count-1 do
  begin
    aint := StrToInt(copy(sTexture[i],Pos('=',sTexture[i])+1,length(sTexture[0])));
    ahex := '$'+IntToHex(aint,4);
    lbTexture.Items.Add(ahex);
  end;
  sTexture.Free;
end;

procedure TWFFOptions.FormCreate(Sender: TObject);
var
  xmlParser : TXmlParser;
  ANamedTile : TTileNamed;
  MyListItem : TListItem;
  {ahex, }aname : string;
 // aint, i : integer;
 // sTexture : TStringList;
  rSearchRec : TSearchRec;
begin
  lvSelectModes.Items.Clear;
  xmlParser := TXmlParser.Create;
  xmlParser.LoadFromFile(MainForm.Appath+'tilelist.xml');
  xmlParser.StartScan;
  ANamedTile := TTileNamed.Create;
  while xmlParser.Scan do
  begin
    if (xmlParser.CurPartType = ptStartTag) and (xmlParser.CurName = 'Tile') then
      ANamedTile.TileIds.Clear;
    if ((xmlParser.CurPartType = ptContent) or (xmlParser.CurPartType = ptCData))
    and (xmlParser.CurName = 'Name') then
    begin
      ANamedTile.TileName := xmlParser.CurContent;
      aname := xmlParser.CurContent;
    end;
    if ((xmlParser.CurPartType = ptContent) or (xmlParser.CurPartType = ptCData))
    and (xmlParser.CurName = 'TileId') then
    begin
      ANamedTile.TileIds.Add(xmlParser.CurContent);
    end;
    if (xmlParser.CurPartType = ptEndTag) and (xmlParser.CurName = 'Tile') then
    begin
      MyListItem := lvSelectModes.Items.Add;
      MyListItem.Caption := ANamedTile.TileName;
      MyListItem.SubItems.Add(ANamedTile.TileIds.CommaText);
    end;
  end;
  xmlParser.Free;
  loadTextureList('tileids.lst');

  // Combo fllen
  cbTextureLists.Items.Clear;
  if FindFirst(MainForm.Appath+'Textures\*.lst', faDirectory, rSearchRec) = 0 then
    cbTextureLists.Items.Add(rSearchRec.Name);
  while FindNext(rSearchRec) = 0 do
    if (rSearchRec.Name <> '.') and (rSearchRec.Name <> '..') then
      cbTextureLists.Items.Add(rSearchRec.Name);
  cbTextureLists.Text := 'tileids.lst';
  FindClose(rSearchRec);
end;

procedure TWFFOptions.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   //
end;

procedure TWFFOptions.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //
end;

procedure TWFFOptions.btnAddClick(Sender: TObject);
var
  MyListItem : TListItem;
begin
  DlgSelectMode := TDlgSelectMode.Create(Application);
  DlgSelectMode.lblHelpText.Caption := 'Seperate Tile IDs with Comma! '
                                      +'Insert Tile ID as Hex (Sample: $011a)';
  DlgSelectMode.Caption := 'Add new Tiles';
  if DlgSelectMode.ShowModal = mrOk then
  begin
    MyListItem := lvSelectModes.Items.Add;
    MyListItem.Caption := DlgSelectMode.edCaption.Text;
    MyListItem.SubItems.Add(DlgSelectMode.edTileList.Lines.Text);
  end;
end;

procedure TWFFOptions.lvSelectModesSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  btnEdit.Enabled := Selected;
  btnDelete.Enabled := Selected;
  if Item.Index > 0 then
    btnUp.Enabled := Selected;
  if Item.Index < lvSelectModes.Items.Count-1 then
    btnDown.Enabled := Selected;
end;

procedure TWFFOptions.btnEditClick(Sender: TObject);
begin
  DlgSelectMode := TDlgSelectMode.Create(Application);
  DlgSelectMode.Caption := 'Edit Group '+lvSelectModes.Selected.Caption;
  DlgSelectMode.edCaption.Text := lvSelectModes.Selected.Caption;
  DlgSelectMode.edTileList.Lines.Text := lvSelectModes.Selected.SubItems.Text;
  if DlgSelectMode.ShowModal = mrOk then
  begin
    lvSelectModes.Selected.Caption := DlgSelectMode.edCaption.Text;
    lvSelectModes.Selected.SubItems.Text := DlgSelectMode.edTileList.Lines.Text;
  end;
end;

procedure TWFFOptions.btnDeleteClick(Sender: TObject);
begin
  if MessageDlg('Delete selected selection group?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    lvSelectModes.Selected.Delete;
end;

procedure TWFFOptions.btnUpClick(Sender: TObject);
var
  MyListItem, newListItem : TListItem;
  oldindex, newindex : integer;
  acaption, asubstring : String;
begin
  oldindex := lvSelectModes.Selected.Index;
  MyListItem := lvSelectModes.Selected;
  newindex := oldindex-1;
  acaption := MyListItem.Caption;
  asubstring := MyListItem.SubItems.Text;
  lvSelectModes.Selected.Delete;
  newListItem := lvSelectModes.Items.Insert(newindex);
  newListItem.Caption := acaption;
  newListItem.SubItems.Text := asubstring;
  lvSelectModes.ItemFocused := lvSelectModes.Items.Item[newindex];
  lvSelectModes.Selected := lvSelectModes.Items.Item[newindex];
  lvSelectModes.SetFocus;
end;

procedure TWFFOptions.btnDownClick(Sender: TObject);
var
  MyListItem, newListItem : TListItem;
  oldindex, newindex : integer;
  acaption, asubstring : String;
begin
  oldindex := lvSelectModes.Selected.Index;
  MyListItem := lvSelectModes.Selected;
  newindex := oldindex+1;
  acaption := MyListItem.Caption;
  asubstring := MyListItem.SubItems.Text;
  lvSelectModes.Selected.Delete;
  newListItem := lvSelectModes.Items.Insert(newindex);
  newListItem.Caption := acaption;
  newListItem.SubItems.Text := asubstring;
  lvSelectModes.ItemFocused := lvSelectModes.Items.Item[newindex];
  lvSelectModes.Selected := lvSelectModes.Items.Item[newindex];
  lvSelectModes.SetFocus;
end;

procedure TWFFOptions.lbTextureClick(Sender: TObject);
var
  Bitmap: TBitmap;
  id : integer;
  rect : TRect;
begin
  if lbTexture.ItemIndex > -1 then
  begin
    Bitmap := TBitmap.Create;
    Bitmap.Width := 1; // LoadXYZ sets them
    Bitmap.Height := 1;
    Bitmap.PixelFormat := pf15bit;
    id := StrToInt(lbTexture.Items[lbTexture.ItemIndex]);
    if not LoadTexture(id, Bitmap) then
      if not LoadArt(id, Bitmap) then
      begin
      end;
    rect := Image1.ClientRect;
    Image1.Canvas.StretchDraw(rect, Bitmap);
    Bitmap.Free;
    btnEditTexture.Enabled := True;
    btnDeleteTexture.Enabled := True;
    if lbTexture.ItemIndex > 0 then
      btnTextureUp.Enabled := True
    else
      btnTextureUp.Enabled := False;
    if lbTexture.ItemIndex < lbTexture.Count -1 then
      btnTextureDown.Enabled := True
    else
      btnTextureDown.Enabled := False;
  end
  else
  begin
    btnEditTexture.Enabled := False;
    btnDeleteTexture.Enabled := False;
    btnTextureUp.Enabled := False;
    btnTextureDown.Enabled := False;
  end;
end;

procedure TWFFOptions.btnTextureUpClick(Sender: TObject);
var
  oldindex, newindex : integer;
  id : String;
begin
  oldindex := lbTexture.ItemIndex;
  id := lbTexture.Items[oldindex];
  newindex := oldindex-1;
  lbTexture.DeleteSelected;
  lbTexture.Items.Insert(newindex,id);
  lbTexture.ItemIndex := newindex;
  lbTexture.SetFocus;
end;

procedure TWFFOptions.btnTextureDownClick(Sender: TObject);
var
  oldindex, newindex : integer;
  id : String;
begin
  oldindex := lbTexture.ItemIndex;
  id := lbTexture.Items[oldindex];
  newindex := oldindex+1;
  lbTexture.DeleteSelected;
  lbTexture.Items.Insert(newindex,id);
  lbTexture.ItemIndex := newindex;
  lbTexture.SetFocus;
end;

procedure TWFFOptions.btnAddTextureClick(Sender: TObject);
var
  index : integer;
begin
  WFFAddTile := TWFFAddTile.Create(Application);
  WFFAddTile.Caption := 'Insert';
  WFFAddTile.edAddTile.EditLabel.Caption := 'Insert a new Item';
  WFFAddTile.edAddTile.Text := '$';
  if WFFAddTile.ShowModal = mrOk then
  begin
    if lbTexture.ItemIndex > -1 then
    begin
      index := lbTexture.ItemIndex;
      lbTexture.Items.Insert(index,WFFAddTile.edAddTile.Text);
    end
    else
      lbTexture.Items.Add(WFFAddTile.edAddTile.Text);
  end;
end;

procedure TWFFOptions.btnEditTextureClick(Sender: TObject);
var
  index : integer;
begin
  index := lbTexture.ItemIndex;
  WFFAddTile := TWFFAddTile.Create(Application);
  WFFAddTile.Caption := 'Edit';
  WFFAddTile.edAddTile.EditLabel.Caption := 'Edit Item '+lbTexture.Items[index];
  WFFAddTile.edAddTile.Text := '$';
  if WFFAddTile.ShowModal = mrOk then
    lbTexture.Items[index] := WFFAddTile.edAddTile.Text;
end;

procedure TWFFOptions.btnDeleteTextureClick(Sender: TObject);
begin
  if MessageDlg('Delete selected Item?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    lbTexture.DeleteSelected;
end;

procedure TWFFOptions.cbTextureListsChange(Sender: TObject);
begin
  lbTexture.Items.Clear;
  LoadTextureList(cbTextureLists.Text);
end;

procedure TWFFOptions.btnAddListClick(Sender: TObject);
var
  listname : String;
begin
  listname := '.lst';
  if InputQuery('Add List', 'Add new Item list', listname) then
  begin
    lbTexture.Items.Clear;
    cbTextureLists.Text := listname;
    cbTextureLists.Items.Add(listname);
  end;
end;

end.
