// Copyright (c) 1998, 1999, 2000 Jan Luebbe. All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Jan Luebbe can be emailed at jluebbe@lasnet.de

unit WFMapEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Grids, StdCtrls, ComCtrls, Buttons, Menus, Mask, Math, LibXmlParser,
  WFTools, Contnrs;

Type
  // Shinigami - 2004/05/21
  TMulFile = Class(TObject)
  Private
    FStream: TFileStream;
    FName: String;
    FOpened: Boolean;
    Function Open(Const AName: String): Boolean;
    Procedure Close;
  Protected
    Property Name: String Read FName;
    Property Opened: Boolean Read FOpened;
  Public
    Constructor Create;
    Destructor Destroy; Override;
    Function Read(Const AName: String; Const AOffset: LongInt; Var ABuffer; Const ACount: Longint): Longint;
    Function Write(Const AName: String; Const AOffset: LongInt; Var ABuffer; Const ACount: Longint): Longint;
  End;

  TWFMapEditForm = Class(TForm)
    RightPanel: TPanel;
    MainDrawGrid: TDrawGrid;
    FileNamePanel: TPanel;
    MapLabel: TLabel;
    MapEdit: TEdit;
    UOPathLabel: TLabel;
    UOPathEdit: TEdit;
    StatusBar: TStatusBar;
    BottomPanel: TPanel;
    AltitudePanel: TPanel;
    DrawSettingsPanel: TPanel;
    SelectDrawingModeLabel: TLabel;
    SelectDrawingModeComboBox: TComboBox;
    TextureDrawGrid: TDrawGrid;
    AltitudeRadioGroup: TRadioGroup;
    MapEditDestination: TEdit;
    MapEditSource: TEdit;
    MapLabelSource: TLabel;
    MapLabelDestination: TLabel;
    Shape3: TShape;
    LeftPanel: TPanel;
    GridBox: TRadioGroup;
    ShowAltitudeRadioGroup: TRadioGroup;
    GroupBox1: TGroupBox;
    JumpXLabel: TLabel;
    XJumpEdit: TEdit;
    YJumpLabel: TLabel;
    YJumpEdit: TEdit;
    TopPanel: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    eXit1: TMenuItem;
    Import1: TMenuItem;
    ZValueLabel: TLabel;
    ZValueEdit: TEdit;
    XValueUpDown: TUpDown;
    Export1: TMenuItem;
    N1: TMenuItem;
    oText1: TMenuItem;
    oBitmap1: TMenuItem;
    Spezial1: TMenuItem;
    ChangeTile1: TMenuItem;
    CreatenewTile1: TMenuItem;
    EditTile1: TMenuItem;
    N2: TMenuItem;
    FromText1: TMenuItem;
    FromBitmap1: TMenuItem;
    GroupBox2: TGroupBox;
    GroupBox4: TGroupBox;
    BrushSizeEdt: TMaskEdit;
    BrushSizeMover: TUpDown;
    BitBtn3: TBitBtn;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    CoordGoBtn: TSpeedButton;
    N3: TMenuItem;
    ShowTextureID1: TMenuItem;
    HideunusedTexture1: TMenuItem;
    SpeedButton4: TSpeedButton;
    cbAddRAl: TCheckBox;
    Label11: TLabel;
    udRValue: TUpDown;
    edRauschen: TEdit;
    Label12: TLabel;
    btnHoehle1: TSpeedButton;
    btnHoehle2: TSpeedButton;
    btnHoehle3: TSpeedButton;
    btnHoehle4: TSpeedButton;
    btnHoehle5: TSpeedButton;
    btnHoehle6: TSpeedButton;
    btnHoehle7: TSpeedButton;
    btnHoehle8: TSpeedButton;
    btnHoehle9: TSpeedButton;
    btnHoehle10: TSpeedButton;
    btnHoehle11: TSpeedButton;
    btnHoehle12: TSpeedButton;
    btnHoehle13: TSpeedButton;
    btnHoehle14: TSpeedButton;
    N4: TMenuItem;
    coloredAltitude: TMenuItem;
    ShowonlyColor1: TMenuItem;
    ShowAltitude1: TMenuItem;
    Panel1: TPanel;
    edFindID: TEdit;
    Label13: TLabel;
    btnFind: TSpeedButton;
    SortedTextureGrid: TStringGrid;
    cbSortet: TCheckBox;
    N5: TMenuItem;
    Options1: TMenuItem;
    btnCustomTextures: TSpeedButton;
    pmCustomTextures: TPopupMenu;
    btnDefault: TSpeedButton;
    saveExport: TSaveDialog;
    btnRectFill: TSpeedButton;
    btnFloodFill: TSpeedButton;
    btnCustomBrush: TSpeedButton;
    cbCustomBrushes: TComboBox;
    CustomBrushesEdit: TSpeedButton;
    MapComboBoxSource: TComboBox;
    MapComboBoxDestination: TComboBox;
    SX1Label: TLabel;
    SX1Edit: TEdit;
    SX1UpDown: TUpDown;
    SY1Label: TLabel;
    SY1Edit: TEdit;
    SY1UpDown: TUpDown;
    SX2Label: TLabel;
    SX2Edit: TEdit;
    SX2UpDown: TUpDown;
    SY2Label: TLabel;
    SY2Edit: TEdit;
    SY2UpDown: TUpDown;
    DX1Label: TLabel;
    DX1Edit: TEdit;
    DX1UpDown: TUpDown;
    DY1Label: TLabel;
    DY1Edit: TEdit;
    DY1UpDown: TUpDown;
    DX2Label: TLabel;
    DX2Edit: TEdit;
    DY2Label: TLabel;
    DY2Edit: TEdit;
    CopyMapButton: TButton;
    Label1: TLabel;
    ProgressBar: TProgressBar;
    MapComboBox: TComboBox;
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    Procedure MapEditChange(Sender: TObject);
    Procedure MapComboBoxChange(Sender: TObject);
    Procedure UOPathEditChange(Sender: TObject);
    procedure TextureDrawGridDrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure MainDrawGridDrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure TextureDrawGridClick(Sender: TObject);
    procedure MainDrawGridSelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure MainDrawGridMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SelectDrawingModeComboBoxChange(Sender: TObject);
    procedure ZValueEditChange(Sender: TObject);
    procedure AltitudeRadioGroupClick(Sender: TObject);
    procedure ShowAltitudeRadioGroupClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GridBoxClick(Sender: TObject);
    procedure eXit1Click(Sender: TObject);
    procedure MapEditCloseBtnClick(Sender: TObject);
    procedure CoordGoBtnClick(Sender: TObject);
    procedure ZoomInClick(Sender: TObject);
    procedure ZoomOutClick(Sender: TObject);
    procedure MainDrawGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BrushSizeMoverClick(Sender: TObject; Button: TUDBtnType);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShowTextureID1Click(Sender: TObject);
    procedure HideunusedTexture1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure udRValueClick(Sender: TObject; Button: TUDBtnType);
    procedure coloredAltitudeClick(Sender: TObject);
    procedure ShowonlyColor1Click(Sender: TObject);
    procedure ShowAltitude1Click(Sender: TObject);
    procedure MainDrawGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnFindClick(Sender: TObject);
    procedure SortedTextureGridClick(Sender: TObject);
    procedure SortedTextureGridDrawCell(Sender: TObject; ACol,
      ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure cbSortetClick(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure btnCustomTexturesClick(Sender: TObject);
    procedure oText1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CustomBrushesEditClick(Sender: TObject);
    procedure cbCustomBrushesChange(Sender: TObject);
    Procedure MapEditSourceChange(Sender: TObject);          // <MapCopy>
    Procedure MapEditDestinationChange(Sender: TObject);
    Procedure MapComboBoxSourceChange(Sender: TObject);
    Procedure MapComboBoxDestinationChange(Sender: TObject);
    Procedure SX1EditChange(Sender: TObject);
    Procedure SX1EditExit(Sender: TObject);
    Procedure SY1EditChange(Sender: TObject);
    Procedure SY1EditExit(Sender: TObject);
    Procedure SX2EditChange(Sender: TObject);
    Procedure SX2EditExit(Sender: TObject);
    Procedure SY2EditChange(Sender: TObject);
    Procedure SY2EditExit(Sender: TObject);
    Procedure DX1EditChange(Sender: TObject);
    Procedure DX1EditExit(Sender: TObject);
    Procedure DY1EditChange(Sender: TObject);
    Procedure DY1EditExit(Sender: TObject);
    Procedure CopyMapButtonClick(Sender: TObject);           // </MapCopy>
  Private
   // FNamedTile : TObjectList;
    fillFirstClick : Boolean;
    fillRect : TRect;
    FBrush : TStringList;
    MaxXSource:         Integer; // <MapCopy>
    MaxYSource:         Integer;
    MapSizeSource:      Integer;
    MaxXDestination:    Integer;
    MaxYDestination:    Integer;
    MapSizeDestination: Integer; // </MapCopy>
    Procedure CheckMapCopyParams(Sender: TObject);
    function findRow(id : integer): integer;
    procedure loadSelectModes;
    procedure loadTextureList(FileName : String);
    procedure loadBookMarks;
    procedure loadBrushes;
    procedure loadBrush(brushName : String);
    procedure mnCustomTexturesClick(Sender: TObject);
    procedure createMenue(FileName : String);
    Function FileSize(Const AName: String): Integer;
    Procedure MapEditChangeSub(Sender: TObject);
  Public
    MapFile: TMulFile;
  End;

var
   WFMapEditForm: TWFMapEditForm;
   Key_Move : Boolean;
   Map_Open : Boolean;
  // MapFile: file of byte;

type
  // Select random
  DrawingMode = (
    off,
    selected,
    altitude_only,
    dynamic_start
  );
  // TexIdx.mul
  TTexturePointer = packed record
    Start, Length, Unknown: longint;
  end;
  // TexMaps.mul
  TTextureBuffer = packed array[0..(128*128*2)-1] of byte;
  // ArtIdx.mul
  TArtPointer = packed record
    Start: longword;
    Length, Unknown: longint;
  end;
  // Art.mul is handled internally

// Textures and Art
function LoadTexture(const TileID: word; var bitmap: TBitmap):boolean;
function LoadArt(const TileID: word; var bitmap: TBitmap):boolean;

// Registry
Procedure LoadFileNames(Var MapFileName, UOPathName: String);
Procedure SaveFileNames(Const MapFileName, UOPathName: String);

// UI
function FileNamesCorrect:boolean;

implementation

{$R *.DFM}
{$R zahlen.res}

uses Main, Registry, Tools, WFWorldView, WFDlgOptions, WFDlgCustomBrush;

// Textures and Art
function LoadTexture(const TileID: word; var Bitmap: TBitmap):boolean;
var
  TexIdxFile: file of byte;
  TexMapsFile: file of byte;
  TexturePointer: TTexturePointer;
  TextureBuffer: TTextureBuffer;
  SideLength, X, Y: integer;
  P: PByteArray;
begin
  //if (not FileNamesCorrect) or (TileID >= 16382) then
  if (not FileNamesCorrect) or (TileID >= 4096) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(TexIdxFile, WFMapEditForm.UOPathEdit.Text+'\texidx.mul');
  Reset(TexIdxFile);
  Seek(TexIdxFile, TileID*12);
  BlockRead(TexIdxFile, TexturePointer, SizeOf(TTexturePointer));
  CloseFile(TexIdxFile);
  case TexturePointer.Length of
    $2000: SideLength := 64;
    $8000: SideLength := 128;
  else
    Result := False;
    Exit;
  end;
  AssignFile(TexMapsFile, WFMapEditForm.UOPathEdit.Text+'\texmaps.mul');
  Reset(TexMapsFile);
  Seek(TexMapsFile, TexturePointer.Start);
  BlockRead(TexMapsFile, TextureBuffer, TexturePointer.Length);
  CloseFile(TexMapsFile);
  // Reading file done
  Bitmap.Width := SideLength;
  Bitmap.Height := SideLength;
  Bitmap.PixelFormat := pf15bit;
  {$R-}
  begin
    for Y := 0 to SideLength-1 do
    begin
      P := Bitmap.ScanLine[Y];
      for X := 0 to SideLength-1 do
      begin
        P[X*2{15Bit}  ] := TextureBuffer[(Y*SideLength+X)*2  ];
        P[X*2{15Bit}+1] := TextureBuffer[(Y*SideLength+X)*2+1];
      end;
    end;
  end;
  {$R+}
  Result := True;
end;

//hoenie
function LoadArt(const TileID: word; var Bitmap: TBitmap):boolean;
var
  ArtIdxFile: file of byte;
  ArtFile: file of byte;
  ArtPointer: TArtPointer;
  TempArray: array[0..16382] of byte;
  // TempArray: array[0..2047] of byte;
  TempMap: array[0..45, 0..45, 0..1] of byte;
  i, X, Y, XStart, YStart: integer;
  P: PByteArray;
begin
  Result:=False;
	case tileid of
   	$0007,$0008:exit;
   end;
  if (not FileNamesCorrect) or (TileID >= 16382) then
  //if (not FileNamesCorrect) or (TileID >= 4096) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(ArtIdxFile, WFMapEditForm.UOPathEdit.Text+'\artidx.mul');
  Reset(ArtIdxFile);
  Seek(ArtIdxFile, TileID*12);
  BlockRead(ArtIdxFile, ArtPointer, SizeOf(TArtPointer));
  CloseFile(ArtIdxFile);
  if (ArtPointer.Start = $FFFFFFFF) or
    not (ArtPointer.Length = 2048) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(ArtFile, WFMapEditForm.UOPathEdit.Text+'\art.mul');
  Reset(ArtFile);
  Seek(ArtFile, ArtPointer.Start);
  BlockRead(ArtFile, TempArray, ArtPointer.Length-4);
  CloseFile(ArtFile);
  // Reading file done
  Bitmap.Width := 45;
  Bitmap.Height := 45;
  Bitmap.PixelFormat := pf15bit;
  Bitmap.Canvas.Brush.Color := clBlack;
  Bitmap.Canvas.FillRect(Bitmap.Canvas.ClipRect);

  i := 0;
  XStart := 0;
  YStart := 1;

  ZeroMemory(Addr(TempMap), SizeOf(TempMap));

  {$R-}
  while True do
  begin
    X := XStart;
    Y := YStart;
    while (X <= 44) and (Y >= 0) do
    begin
      TempMap[X, Y][0] := TempArray[i];
      TempMap[X, Y][1] := TempArray[i+1];
      TempMap[X+1, Y][0] := TempArray[i];
      TempMap[X+1, Y][1] := TempArray[i+1];
      TempMap[X, Y+1][0] := TempArray[i];
      TempMap[X, Y+1][1] := TempArray[i+1];
      Inc(i, 2);
      Inc(X, 1);
      Dec(Y, 1);
    end;
    if YStart < 43 then
    begin
      Inc(YStart, 2);
    end
    else if YStart = 43 then
    begin
      Inc(YStart, 1);
      Inc(XStart, 1);
    end
    else // YStart = 44
    begin
      Inc(XStart, 2);
    end;
    if XStart > 43 then Break;
  end;

  begin
    for Y := 0 to 44 do
    begin
      P := Bitmap.ScanLine[Y];
      for X := 0 to 44 do
      begin
        P[X*2{15Bit}  ] := TempMap[X, Y][0];
        P[X*2{15Bit}+1] := TempMap[X, Y][1];
      end;
    end;
  end;
  {$R+}

  Result := True;
end;

// Registry
// 2004/05/15 - Shinigami
Procedure LoadFileNames(Var MapFileName, UOPathName: String);
Var Registry: TRegistry;
Begin
  Registry:=TRegistry.Create;
  Registry.OpenKey('\Software\Ridcully\WorldForge', False);

  Case WFMapEditForm.MapComboBox.ItemIndex of
    Map0_Britannia: Begin
                      MapFileName                 :=Registry.ReadString('Map0.mul');
                      WFMapEditForm.XJumpEdit.Text:=Registry.ReadString('CoordX0');
                      WFMapEditForm.YJumpEdit.Text:=Registry.ReadString('CoordY0');
                    End;
    Map2_Illshenar: Begin
                      MapFileName                 :=Registry.ReadString('Map2.mul');
                      WFMapEditForm.XJumpEdit.Text:=Registry.ReadString('CoordX2');
                      WFMapEditForm.YJumpEdit.Text:=Registry.ReadString('CoordY2');
                    End;
    Map3_Malas:     Begin
                      MapFileName                 :=Registry.ReadString('Map3.mul');
                      WFMapEditForm.XJumpEdit.Text:=Registry.ReadString('CoordX3');
                      WFMapEditForm.YJumpEdit.Text:=Registry.ReadString('CoordY3');
                    End;
  End;
  UOPathName:=Registry.ReadString('UOPath');

  Registry.CloseKey;
  Registry.Free;

  WFMapEditForm.MapFile.Open(MapFileName);
 (* AssignFile(MapFile, MapFileName);
  {$I-} Reset(MapFile) {$I+}; *)
End;

// 2004/05/15 - Shinigami
Procedure SaveFileNames(Const MapFileName, UOPathName: String);
Var Registry: TRegistry;
Begin
  Registry:=TRegistry.Create;
  Registry.OpenKey('\Software\Ridcully\WorldForge', True);

  Case WFMapEditForm.MapComboBox.ItemIndex of
    Map0_Britannia: Begin
                      Registry.WriteString('Map0.mul', MapFileName);
                      Registry.WriteString('CoordX0',  WFMapEditForm.XJumpEdit.Text);
                      Registry.WriteString('CoordY0',  WFMapEditForm.YJumpEdit.Text);
                    End;
    Map2_Illshenar: Begin
                      Registry.WriteString('Map2.mul', MapFileName);
                      Registry.WriteString('CoordX2',  WFMapEditForm.XJumpEdit.Text);
                      Registry.WriteString('CoordY2',  WFMapEditForm.YJumpEdit.Text);
                    End;
    Map3_Malas:     Begin
                      Registry.WriteString('Map3.mul', MapFileName);
                      Registry.WriteString('CoordX3',  WFMapEditForm.XJumpEdit.Text);
                      Registry.WriteString('CoordY3',  WFMapEditForm.YJumpEdit.Text);
                    End;
  End;
  Registry.WriteString('UOPath', UOPathName);

  Registry.CloseKey;
  Registry.Free;

  WFMapEditForm.MapFile.Open(WFMapEditForm.MapEdit.Text);
 (* AssignFile(MapFile, WFMapEditForm.MapEdit.Text);
  {$I-} Reset(MapFile) {$I+}; *)
End;

// UI
function FileNamesCorrect:boolean;
begin
  with WFMapEditForm do
  begin
    if (MapEdit.Color = clGreen) and
       (UOPathEdit.Color = clGreen)
      then
      begin
        Result := True;
        if (MapEdit.Tag = 1) or (UOPathEdit.Tag = 1) then // one has changed
        begin
          SaveFileNames(MapEdit.Text, UOPathEdit.Text);
          MapEdit.Tag := 0;
          UOPathEdit.Tag := 0;
        end;
      end
      else Result := False;
  end;
end;

var
  MouseLastCol, MouseLastRow: integer;

procedure UpdateStatusBar;
var
  s: string;
  MapCell: TMapCell;
  XBlock, YBlock, XOff, YOff: integer;
begin
  with WFMapEditForm do
  begin
    if FileNamesCorrect then
    begin
      XBlock := MouseLastCol div 8;
      YBlock := MouseLastRow div 8;
      XOff := MouseLastCol mod 8;
      YOff := MouseLastRow mod 8;
     // AssignFile(MapFile, WFMapEditForm.MapEdit.Text);
     // Reset(MapFile);
     // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
     // BlockRead(MapFile, MapCell, SizeOf(TMapCell));
     // CloseFile(MapFile);
      WFMapEditForm.MapFile.Read(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
        SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
    end;
    // under mouse
    s := 'X='+IntToStr(MouseLastCol)+' - Y='+IntToStr(MouseLastRow);
    if FileNamesCorrect then
      s := s+' - Altitude='+IntToStr(MapCell.Altitude)+' - Tile='+IntToSpacedHex(MapCell.TileID, 2)
    else
      s := s+' - Wrong filename or filesize';
    StatusBar.Panels[0].Text := s;
    // selected for drawing
    s := 'Selected mode: ';
    case AltitudeRadioGroup.ItemIndex of
      0: s := s+'Add '+IntToStr(StrToInt(ZValueEdit.Text))+' to current altitude';
      1: s := s+'Subtract '+IntToStr(StrToInt(ZValueEdit.Text))+' from current altitude';
      2: s := s+'Set altitude to '+IntToStr(StrToInt(ZValueEdit.Text));
      3: S := s+'Only draw tile without set altitude';
    end;
    case SelectDrawingModeComboBox.ItemIndex of
      Ord(off): s := s+' - Drawing disabled';
      Ord(selected): begin
                       if cbSortet.Checked then
                         s := s+' - Selected tile='+IntToSpacedHex(StrToInt('$'+copy(SortedTextureGrid.Rows[SortedTextureGrid.Row].Text,0,4)), 2)
                       else
                         s := s+' - Selected tile='+IntToSpacedHex(TextureDrawGrid.Row, 2);
                       end;
      Ord(altitude_only): s := s+' - Drawing altitude only';
    else
      s := s+' - Selected group: "'+SelectDrawingModeComboBox.Text+'"';
    end;
    StatusBar.Panels[1].Text := s;
  end;
end;

function TWFMapEditForm.findRow(id : integer): integer;
var
  i : integer;
  a : string;
begin
  result := -1;
  for i := 0 to SortedTextureGrid.RowCount -1 do
  begin
    a := copy(SortedTextureGrid.Rows[i].Text,0,4);
    if StrToInt('$'+a) = id then
    begin
      result := i;
      break;
    end;
  end;
end;

procedure TWFMapEditForm.loadBookMarks;
var
  i : integer;
  xmlParser : TXmlParser;
begin
  i := 0;
  xmlParser := TXmlParser.Create;
  xmlParser.LoadFromFile(MainForm.Appath+'bookmarklist.xml');
  xmlParser.StartScan;
  while xmlParser.Scan do
  begin
    if ((xmlParser.CurPartType = ptContent) or (xmlParser.CurPartType = ptCData))
      and (xmlParser.CurName = 'Col') then
      BookMarks[i].Col := StrToInt(xmlParser.CurContent);
    if ((xmlParser.CurPartType = ptContent) or (xmlParser.CurPartType = ptCData))
      and (xmlParser.CurName = 'Row') then
      BookMarks[i].Row := StrToInt(xmlParser.CurContent);
    if ((xmlParser.CurPartType = ptContent) or (xmlParser.CurPartType = ptCData))
      and (xmlParser.CurName = 'Enabled') then
      if xmlParser.CurContent = 'True' then
        BookMarks[i].isset := True
      else
        BookMarks[i].isset := False;
    if (xmlParser.CurPartType = ptEndTag) and (xmlParser.CurName = 'Bookmark') then
      inc(i);
  end;
  xmlParser.Free;
end;

procedure TWFMapEditForm.loadSelectModes;
var
 // i, index : Integer;
 // idlist : TStringList;
  {ahex, }aname : string;
 // aint : integer;
  xmlParser : TXmlParser;
  ANamedTile : TTileNamed;
begin
  SelectDrawingModeComboBox.Items.Clear;
  SelectDrawingModeComboBox.Items.Add('Don''t draw');
  SelectDrawingModeComboBox.Items.Add('Selected tile from list');
  SelectDrawingModeComboBox.Items.Add('Altitude only');
  xmlParser := TXmlParser.Create;
  xmlParser.LoadFromFile(MainForm.Appath+'tilelist.xml');
  xmlParser.StartScan;
  ANamedTile := TTileNamed.Create;
  while xmlParser.Scan do
  begin
    if (xmlParser.CurPartType = ptStartTag) and (xmlParser.CurName = 'Tile') then
      ANamedTile.TileIds.Clear;
    if ((xmlParser.CurPartType = ptContent) or (xmlParser.CurPartType = ptCData))
    and (xmlParser.CurName = 'Name') then
    begin
      ANamedTile.TileName := xmlParser.CurContent;
      aname := xmlParser.CurContent;
    end;
    if ((xmlParser.CurPartType = ptContent) or (xmlParser.CurPartType = ptCData))
    and (xmlParser.CurName = 'TileId') then
    begin
      ANamedTile.TileIds.Add(xmlParser.CurContent);
    end;
    if (xmlParser.CurPartType = ptEndTag) and (xmlParser.CurName = 'Tile') then
    begin
      SelectDrawingModeComboBox.AddItem(aname,TTileNamed.Create);
      TTileNamed(SelectDrawingModeComboBox.Items.Objects[SelectDrawingModeComboBox.Items.IndexOf(aname)]).TileName := ANamedTile.TileName;
      TTileNamed(SelectDrawingModeComboBox.Items.Objects[SelectDrawingModeComboBox.Items.IndexOf(aname)]).TileIds.Assign(ANamedTile.TileIds);
    end;
  end;
  xmlParser.Free;
  ANamedTile.Free;
  SelectDrawingModeComboBox.ItemIndex := 0;
end;

// 2004/07/06 Shinigami - Removed AutoHotKeys from TextureMenu
procedure TWFMapEditForm.createMenue(FileName : String);
var
  rSearchRec : TSearchRec;
  NewItem    : TMenuItem;
begin
  pmCustomTextures.Items.Clear;
  pmCustomTextures.AutoHotkeys:=maManual; // Shinigami
  if FindFirst(MainForm.Appath+'Textures\*.lst', faDirectory, rSearchRec) = 0 then
  begin
    NewItem := TMenuItem.Create(self);
    NewItem.Caption := rSearchRec.Name;
    NewItem.OnClick := mnCustomTexturesClick;
    pmCustomTextures.Items.Add(NewItem);
    NewItem.GroupIndex := 1;
    NewItem.RadioItem := True;
    if rSearchRec.Name = FileName then
      NewItem.Checked := True;
  end;
  while FindNext(rSearchRec) = 0 do
  begin
    if (rSearchRec.Name <> '.') and (rSearchRec.Name <> '..') then
    begin
      //cbHTMLVorlagenName.Items.Add(rSearchRec.Name);
      NewItem := TMenuItem.Create(self);
      NewItem.Caption := rSearchRec.Name;
      NewItem.OnClick := mnCustomTexturesClick;
      pmCustomTextures.Items.Add(NewItem);
      NewItem.GroupIndex := 1;
      NewItem.RadioItem := True;
      if rSearchRec.Name = FileName then
        NewItem.Checked := True;
    end;
  end;
  FindClose(rSearchRec);
end;

// 2004/07/06 Shinigami - Brushes DropDownBox will show up to 25 entries now
procedure TWFMapEditForm.loadBrushes;
var
  rSearchRec : TSearchRec;
begin
  cbCustomBrushes.Items.Clear;
  if FindFirst(MainForm.Appath+'Brushes\*.brs', faDirectory, rSearchRec) = 0 then
    cbCustomBrushes.Items.Add(copy(ExtractFileName(rSearchRec.Name),0,length(ExtractFileName(rSearchRec.Name))-4));
  while FindNext(rSearchRec) = 0 do
    if (rSearchRec.Name <> '.') and (rSearchRec.Name <> '..') then
      cbCustomBrushes.Items.Add(copy(ExtractFileName(rSearchRec.Name),0,length(ExtractFileName(rSearchRec.Name))-4));

  If cbCustomBrushes.Items.Count<25 Then // Shinigami
    cbCustomBrushes.DropDownCount:=cbCustomBrushes.Items.Count Else cbCustomBrushes.DropDownCount:=25;
end;

procedure TWFMapEditForm.loadBrush(brushName : String);
begin
  FBrush.Clear;
  FBrush.LoadFromFile(MainForm.Appath+'Brushes\'+brushName+'.brs');
end;

procedure TWFMapEditForm.loadTextureList(FileName : String);
var
  i : Integer;
  idlist : TStringList;
  ahex : string;
  aint : integer;
begin
  idlist := TStringList.Create;
  idlist.LoadFromFile(MainForm.Appath+'Textures\'+FileName);
  SortedTextureGrid.RowCount := idlist.Count;
  for i := 0 to SortedTextureGrid.RowCount-1 do
  begin
    aint := StrToInt(copy(idlist[i],Pos('=',idlist[i])+1,length(idlist[0])));
    ahex := IntToHex(aint,4);
    SortedTextureGrid.Cells[0,i] := ahex;
  end;
  idlist.Free;
  SortedTextureGrid.Repaint;
end;

// 2004/07/06 Shinigami - Removed AutoHotKeys from TextureMenu
Procedure TWFMapEditForm.mnCustomTexturesClick(Sender: TObject);
Var FileName: String;
Begin
  (sender as TMenuItem).Checked:=True;
 // FileName := copy((sender as TMenuItem).Caption,2,length((sender as TMenuItem).Caption));
  FileName:=(sender as TMenuItem).Caption; // Shinigami
  loadTextureList(FileName);
End;

procedure TWFMapEditForm.FormResize(Sender: TObject);
begin
  StatusBar.Panels[0].Width := StatusBar.Width div 2;
  StatusBar.Panels[1].Width := StatusBar.Width div 2;
end;

// 2004/05/15 - Shinigami
procedure TWFMapEditForm.FormShow(Sender: TObject);
var
  MapFileName, UOPathName: string;
{  index : integer;
  count : integer;
  setID : boolean;
  Bitmap: TBitmap;
  test : TStringList;  }
begin
  Randomize;
  LoadFileNames(MapFileName, UOPathName);
  MapEdit.Text := MapFileName;
  UOPathEdit.Text := UOPathName;
  SelectDrawingModeComboBox.ItemIndex := Ord(off);
  MainDrawGrid.ColCount:=MainForm.MapWidth*8;
  MainDrawGrid.RowCount:=MainForm.MapHeight*8;
//  TextureDrawGrid.RowCount := $0A00; // no tiles after that number
  UpdateStatusBar;
  {test := TStringList.Create;
  Bitmap := TBitmap.Create;
  Bitmap.Width := 1; // LoadXYZ sets them
  Bitmap.Height := 1;
  Bitmap.PixelFormat := pf15bit;
  count := 0;
  for index := 0 to 4095 do
  begin
    setID := True;
    if not LoadTexture(index, Bitmap) then
      if not LoadArt(index, Bitmap) then
        setID := False;
    if setID then
    begin
      inc(count);
      SortedTextureGrid.RowCount := count;
      SortedTextureGrid.Cells[0,count-1] := IntToStr(index);
      test.Add('textureid='+IntToStr(index));
    end;
  end;
  test.SaveToFile('C:\tileids.lst');
  test.Free; }
end;

// 2004/07/02 Shinigami: New
Function TWFMapEditForm.FileSize(Const AName: String): Integer;
Var SearchRec: TSearchRec;
Begin
  If FindFirst(AName, faAnyFile, SearchRec)=0 Then Result:=SearchRec.Size Else Result:=-1;
  FindClose(SearchRec);
End;

// 2004/07/06 Shinigami: New
Procedure TWFMapEditForm.MapEditChangeSub(Sender: TObject);
Begin
  MainForm.MapComboBox.ItemIndex:=MapComboBox.ItemIndex;
  MainForm.MapComboBoxChange(Sender);

  MapEdit.Tag:=1; // is changed
  If FileExists(MapEdit.Text) And (FileSize(MapEdit.Text)=MainForm.MapSize) Then Begin
    MapEdit.Color:=clGreen;MainDrawGrid.Invalidate;
  End Else MapEdit.Color:=clRed;
  FileNamesCorrect;

  If Not FileExists(MapEditSource.Text) Then MapEditSource.Text:=MapEdit.Text;
  If Not FileExists(MapEditDestination.Text) Then MapEditDestination.Text:=MapEdit.Text;
End;

// 2004/05/26 - Shinigami
Procedure TWFMapEditForm.MapEditChange(Sender: TObject);
Begin
  If FileExists(MapEdit.Text) Then
    Case FileSize(MapEdit.Text) of
      Map0_Britannia_MapSize: MapComboBox.ItemIndex:=Map0_Britannia;
      Map2_Illshenar_MapSize: MapComboBox.ItemIndex:=Map2_Illshenar;
      Map3_Malas_MapSize:     MapComboBox.ItemIndex:=Map3_Malas;
    End;

  MapEditChangeSub(Sender);
End;

// 2004/07/06 Shinigami: New
Procedure TWFMapEditForm.MapComboBoxChange(Sender: TObject);
Begin
  MapEditChangeSub(Sender);
End;

// 2004/05/26 - Shinigami
Procedure TWFMapEditForm.UOPathEditChange(Sender: TObject);
Begin
  UOPathEdit.Tag:=1; // is changed
  If FileExists(UOPathEdit.Text+'\texidx.mul') And FileExists(UOPathEdit.Text+'\texmaps.mul') And
     FileExists(UOPathEdit.Text+'\artidx.mul') And FileExists(UOPathEdit.Text+'\art.mul') Then Begin
    UOPathEdit.Color:=clGreen;MainDrawGrid.Invalidate;
  End Else UOPathEdit.Color:=clRed;

  FileNamesCorrect;
End;

procedure TWFMapEditForm.TextureDrawGridDrawCell(Sender: TObject; Col, Row: Integer; Rect: TRect; State: TGridDrawState);
var
  Bitmap: TBitmap;
begin
// hoenie
  Bitmap := TBitmap.Create;
  Bitmap.Width := 1; // LoadXYZ sets them
  Bitmap.Height := 1;
  Bitmap.PixelFormat := pf15bit;
  if not LoadTexture(Row, Bitmap) then
    if not LoadArt(Row, Bitmap) then
    begin
      Bitmap.Canvas.Brush.Color := clBlack;
      Bitmap.Canvas.FillRect(Bitmap.Canvas.ClipRect);
    end;
  TextureDrawGrid.Canvas.StretchDraw(Rect, Bitmap);
  if gdSelected	in State then
  begin
    TextureDrawGrid.Canvas.Pen.Color := clRed;
    TextureDrawGrid.Canvas.Brush.Style := bsClear;
    TextureDrawGrid.Canvas.Rectangle(Rect);
  end;
  TextureDrawGrid.Canvas.Brush.Style := bsSolid;
  TextureDrawGrid.Canvas.Brush.Color := clWhite; // default
  if ShowTextureID1.Checked then
    TextureDrawGrid.Canvas.TextOut(Rect.Left+1, Rect.Top+1, ' '+IntToSpacedHex(Row, 2)+' ');
  Bitmap.Free;
end;

procedure TWFMapEditForm.MainDrawGridDrawCell(Sender: TObject; Col,
  Row: Integer; Rect: TRect; State: TGridDrawState);
var
  Bitmap: TBitmap;
  MapCell: TMapCell;
  XBlock, YBlock, XOff, YOff: integer;
  iColor : integer;
  i : integer;
  rborder : TRect;
begin
  Bitmap := TBitmap.Create;
  Bitmap.Width := 1; // LoadXYZ sets them
  Bitmap.Height := 1;
  Bitmap.PixelFormat := pf15bit;

  XBlock := Col div 8;
  YBlock := Row div 8;
  XOff := Col mod 8;
  YOff := Row mod 8;

  if FileNamesCorrect then
  begin
   // AssignFile(MapFile, WFMapEditForm.MapEdit.Text);
   // Reset(MapFile);
   // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
   // BlockRead(MapFile, MapCell, SizeOf(TMapCell));
   // CloseFile(MapFile);
   MapFile.Read(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
     SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));

    if not LoadTexture(MapCell.TileID, Bitmap) then
      if not LoadArt(MapCell.TileID, Bitmap) then
      begin
        Bitmap.Canvas.Brush.Color := clBlack;
        Bitmap.Canvas.FillRect(Bitmap.Canvas.ClipRect);
      end;
  end;
  if not ShowonlyColor1.Checked then
    MainDrawGrid.Canvas.StretchDraw(Rect, Bitmap);
  MainDrawGrid.Canvas.Brush.Color := clWhite; // default
  if gdSelected	in State then
  begin
    if btnHoehle1.Down or btnHoehle2.Down or btnHoehle3.Down or btnHoehle4.Down
    or btnHoehle5.Down or btnHoehle6.Down or btnHoehle7.Down or btnHoehle8.Down
    or btnHoehle9.Down or btnHoehle10.Down or btnHoehle11.Down or btnHoehle12.Down
    or btnHoehle13.Down or btnHoehle14.Down then
      MainDrawGrid.Canvas.Pen.Color := clBlue
    else
      MainDrawGrid.Canvas.Pen.Color := clRed;
    MainDrawGrid.Canvas.Brush.Style := bsClear;
    MainDrawGrid.Canvas.Rectangle(Rect);
  end;
  MainDrawGrid.Canvas.Brush.Style := bsSolid;
  MainDrawGrid.Canvas.Font.Color := clBlack;
  case ShowAltitudeRadioGroup.ItemIndex of
    0: begin
         if coloredAltitude.Checked then
         begin
           case MapCell.Altitude of
             -127..-100 : iColor := 65793; // Graustufen!
             -99..-50 : iColor := 512;
             -49..-1 : iColor := 32896;
             0..50 : iColor := 256; // Grn
             51..100 : iColor := 65793;
             101..127 : iColor := 65537;
           else
             iColor:=0;
           end;
           MainDrawGrid.Canvas.Brush.Color := StringToColor('$'+IntToHex((127+MapCell.Altitude)*iColor,8));
         end;
         if ShowonlyColor1.Checked then
           MainDrawGrid.Canvas.FillRect(Rect);
         if ShowAltitude1.Checked then
           MainDrawGrid.Canvas.TextOut(Rect.Left+1, Rect.Top+1, ' '+IntToStr(MapCell.Altitude)+' ')
         else
           MainDrawGrid.Canvas.TextOut(Rect.Left+1, Rect.Top+1, '    ')
       end;
    1: ;
  end;
  // Bookmarks zeichnen!
  for i := 0 to 9 do
    if BookMarks[i].isset and (BookMarks[i].Col = Col) and (BookMarks[i].Row = Row) then
    begin
      MainDrawGrid.Canvas.Brush.Color := clNavy;
      MainDrawGrid.Canvas.Font.Color := clWhite;
      rborder.Left := Rect.Left+1;
      rborder.Right := Rect.Left+15;
      rborder.Top := Rect.Bottom-15;
      rborder.Bottom := Rect.Bottom-1;
      //MainDrawGrid.Canvas.FrameRect(rborder);
      MainDrawGrid.Canvas.TextOut(Rect.Left+1, Rect.Bottom-15, ' '+IntToStr(i)+' ');
    end;
  Bitmap.Free;
end;

procedure TWFMapEditForm.TextureDrawGridClick(Sender: TObject);
begin
  SelectDrawingModeComboBox.ItemIndex := Ord(selected);
  TextureDrawGrid.Tag := TextureDrawGrid.Row;
  UpdateStatusBar;
end;

procedure TWFMapEditForm.MainDrawGridSelectCell(Sender: TObject; Col,
  Row: Integer; var CanSelect: Boolean);
var
  MapCell{, tmMapCell}: TMapCell;
  XBlock, YBlock, XOff, YOff, TempI, ix, iy, i: integer;
  myBrush : TrBrush;

  procedure do_move(_Col,_Row:Integer);
 { var
    j : integer; }
  begin
    XBlock := _Col div 8;
    YBlock := _Row div 8;
    XOff := _Col mod 8;
    YOff := _Row mod 8;
   // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
   // BlockRead(MapFile, MapCell, SizeOf(TMapCell));
    MapFile.Read(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
      SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));

    if SelectDrawingModeComboBox.ItemIndex = Ord(selected) then
      MapCell.TileID := TextureDrawGrid.Tag;
    if SelectDrawingModeComboBox.ItemIndex >= Ord(dynamic_start) then
      MapCell.TileID := TTileNamed(SelectDrawingModeComboBox.Items.Objects[SelectDrawingModeComboBox.ItemIndex]).getRandomTileID;
    TempI := MapCell.Altitude;
    case AltitudeRadioGroup.ItemIndex of
      0: Inc(TempI, StrToInt(ZValueEdit.Text));
      1: Dec(TempI, StrToInt(ZValueEdit.Text));
      2: TempI := StrToInt(ZValueEdit.Text);
      3: ;
    end;
    if TempI > 127 then
      TempI := 127
    else
      if TempI < -128 then
        TempI := -128;
    if cbAddRAl.Checked then
      TempI := TempI+RandomRange(-StrToInt(edRauschen.Text),StrToInt(edRauschen.Text)+1);
    MapCell.Altitude := TempI;
   // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
   // BlockWrite(MapFile, MapCell, SizeOf(TMapCell));
    MapFile.Write(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
      SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
    MainDrawGridDrawCell(Sender, _Col, _Row, MainDrawGrid.CellRect(_Col, _Row), []);
  end;

  procedure do_move_id(_Col,_Row, hid :Integer);
  var
    hidisset : Boolean;
    ir,ic : integer;
  begin
    hidisset := False;
    {      cols
       rows o o o
            o h o  h-> Ursprung Col, Row
            o o o

            BSP
           -1,-1  0,-1 +1,-1
           -1, 0  0, 0 +1, 0
           -1,+1  0,+1 +1,+1
    }
    for ic := -1 to 1 do
      for ir := -1 to 1 do
      begin
        XBlock := (_Col+ic) div 8;
        YBlock := (_Row+ir) div 8;
        XOff := (_Col-ic) mod 8;
        YOff := (_Row-ir) mod 8;
       // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
       // BlockRead(MapFile, MapCell, SizeOf(TMapCell));
        MapFile.Read(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
          SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
        if (ic <> 0) and (ir <> 0) then
        case hid of
          1: if MapCell.TileID = 467 then
             begin
               hidisset := true;
             end;
        end;
      end;

    XBlock := _Col div 8;
    YBlock := _Row div 8;
    XOff := _Col mod 8;
    YOff := _Row mod 8;
   // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
   // BlockRead(MapFile, MapCell, SizeOf(TMapCell));
    MapFile.Read(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
      SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
    case hid of
      1: if not hidisset then MapCell.TileID := 467;
    end;
    TempI := MapCell.Altitude;
    case AltitudeRadioGroup.ItemIndex of
      0: Inc(TempI, StrToInt(ZValueEdit.Text));
      1: Dec(TempI, StrToInt(ZValueEdit.Text));
      2: TempI := StrToInt(ZValueEdit.Text);
      3: ;
    end;
    if TempI > 127 then
      TempI := 127
    else
      if TempI < -128 then
        TempI := -128;
    MapCell.Altitude := TempI;
   // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
   // BlockWrite(MapFile, MapCell, SizeOf(TMapCell));
    MapFile.Write(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
      SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
    MainDrawGridDrawCell(Sender, _Col, _Row, MainDrawGrid.CellRect(_Col, _Row), []);
  end;

  procedure do_move_ida(_Col,_Row, hid :Integer);
  begin
    XBlock := _Col div 8;
    YBlock := _Row div 8;
    XOff := _Col mod 8;
    YOff := _Row mod 8;
   // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
   // BlockRead(MapFile, MapCell, SizeOf(TMapCell));
    MapFile.Read(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
      SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
    MapCell.TileID := hid;
    TempI := MapCell.Altitude;
    case AltitudeRadioGroup.ItemIndex of
      0: Inc(TempI, StrToInt(ZValueEdit.Text));
      1: Dec(TempI, StrToInt(ZValueEdit.Text));
      2: TempI := StrToInt(ZValueEdit.Text);
      3: ;
    end;
    if TempI > 127 then
      TempI := 127
    else
      if TempI < -128 then
        TempI := -128;
    if cbAddRAl.Checked then
      TempI := TempI+RandomRange(-StrToInt(edRauschen.Text),StrToInt(edRauschen.Text)+1);
    MapCell.Altitude := TempI;
   // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
   // BlockWrite(MapFile, MapCell, SizeOf(TMapCell));
    MapFile.Write(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
      SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
    MainDrawGridDrawCell(Sender, _Col, _Row, MainDrawGrid.CellRect(_Col, _Row), []);
  end;
begin
   if Key_Move then
   begin
     Key_Move := False;
     exit;
   end;
   // Prfen ob Hhlenbutton down ist
   if btnHoehle1.Down or btnHoehle2.Down or btnHoehle3.Down or btnHoehle4.Down
    or btnHoehle5.Down or btnHoehle6.Down or btnHoehle7.Down or btnHoehle8.Down
    or btnHoehle9.Down or btnHoehle10.Down or btnHoehle11.Down or btnHoehle12.Down
    or btnHoehle13.Down or btnHoehle14.Down then
   begin // Hhle Zeichnen
     {      cols
       rows o o o
            o h o
            o o o
     }
     if btnHoehle1.Down then
     begin
       do_move_ida(Col,Row, 467);     // /\
       do_move_ida(Col+1,Row, 468);
       do_move_ida(Col+2,Row, 469);
       do_move_ida(Col,Row+1, 474);
       do_move_ida(Col+1,Row+1, 475);
       do_move_ida(Col+2,Row+1, 470);
     end;
     if btnHoehle2.Down then
     begin
       do_move_ida(Col,Row, 468);      // >
       do_move_ida(Col+1,Row, 469);
       do_move_ida(Col,Row+1, 475);
       do_move_ida(Col+1,Row+1, 470);
       do_move_ida(Col,Row+2, 472);
       do_move_ida(Col+1,Row+2, 471);
     end;
     if btnHoehle3.Down then          // V
     begin
       do_move_ida(Col,Row, 474);
       do_move_ida(Col+1,Row, 475);
       do_move_ida(Col+2,Row, 470);
       do_move_ida(Col,Row+1, 473);
       do_move_ida(Col+1,Row+1, 472);
       do_move_ida(Col+2,Row+1, 471);
     end;
     if btnHoehle4.Down then
     begin
       do_move_ida(Col,Row, 467);    // <
       do_move_ida(Col+1,Row, 468);
       do_move_ida(Col,Row+1, 474);
       do_move_ida(Col+1,Row+1, 475);
       do_move_ida(Col,Row+2, 473);
       do_move_ida(Col+1,Row+2, 472);
     end;
     if btnHoehle5.Down then
     begin
       do_move_ida(Col,Row, 467);     // o
       do_move_ida(Col+1,Row, 468);
       do_move_ida(Col+2,Row, 469);
       do_move_ida(Col,Row+1, 474);
       do_move_ida(Col+1,Row+1, 475);
       do_move_ida(Col+2,Row+1, 470);
       do_move_ida(Col,Row+2, 473);
       do_move_ida(Col+1,Row+2, 472);
       do_move_ida(Col+2,Row+2, 471);
     end;
     if btnHoehle6.Down then
       do_move_ida(Col,Row, 475);
     if btnHoehle7.Down then
       do_move_ida(Col,Row, 467);
     if btnHoehle8.Down then
       do_move_ida(Col,Row, 468);
     if btnHoehle9.Down then
       do_move_ida(Col,Row, 469);
     if btnHoehle10.Down then
       do_move_ida(Col,Row, 474);
     if btnHoehle11.Down then
       do_move_ida(Col,Row, 470);
     if btnHoehle12.Down then
       do_move_ida(Col,Row, 473);
     if btnHoehle13.Down then
       do_move_ida(Col,Row, 472);
     if btnHoehle14.Down then
       do_move_ida(Col,Row, 471);
   end
   else if btnRectFill.Down then
   begin
     if not fillFirstClick then
     begin
       fillRect.Left := Col;
       fillRect.Top := Row;
       fillFirstClick := True;
     end
     else
     begin
       fillRect.Right := Col;
       fillRect.Bottom := Row;
       for ix := fillRect.Left to fillRect.Right do
         for iy := fillRect.Top to fillRect.Bottom do
           do_move(ix, iy);
       fillFirstClick := False;
       fillRect.Left := -1;
       fillRect.Top := -1;
       fillRect.Right := -1;
       fillRect.Bottom := -1;
     end;
   end
   else if btnFloodFill.Down then
   begin
     // Pff wird schwer!

   end
   else if btnCustomBrush.Down then
   begin
     if FBrush.Count > 0 then
       for i := 0 to FBrush.Count -1 do
       begin
         myBrush := TextToBrush(',', FBrush.Strings[i]);
         do_move_ida(col+myBrush.Col,row+myBrush.Row,myBrush.id);
       end;
   end
   else
   begin
     if (SelectDrawingModeComboBox.ItemIndex = Ord(off)) or (not FileNamesCorrect) then Exit;
       do_move(Col,Row);
     if BrushSizeMover.Position > 1 then
     for ix := 0 to BrushSizeMover.Position-1 do
       for iy := 0 to BrushSizeMover.Position-1 do
         do_move(col+ix,row+iy);
   end;
end;

procedure TWFMapEditForm.MainDrawGridMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  MainDrawGrid.MouseToCell(X, Y, MouseLastCol, MouseLastRow);
  if MouseLastCol < 0 then MouseLastCol := 0;
  if MouseLastRow < 0 then MouseLastRow := 0;
  if MouseLastCol >= MainForm.MapWidth*8 then MouseLastCol := MainForm.MapWidth*8-1;
  if MouseLastRow >= MainForm.MapHeight*8 then MouseLastRow := MainForm.MapHeight*8-1;
  UpdateStatusBar;
end;

procedure TWFMapEditForm.SelectDrawingModeComboBoxChange(Sender: TObject);
begin
  UpdateStatusBar;
end;

procedure TWFMapEditForm.ZValueEditChange(Sender: TObject);
var
  TempI: integer;
begin
  try
    TempI := StrToInt(ZValueEdit.Text);
    if TempI > 127 then TempI := 127
    else if TempI < -128 then TempI := -128;
    ZValueEdit.Text := IntToStr(TempI);
    UpdateStatusBar;
  except
    ZValueEdit.Text := '0';
    UpdateStatusBar;
  end;
end;

procedure TWFMapEditForm.AltitudeRadioGroupClick(Sender: TObject);
begin
  UpdateStatusBar;
end;

procedure TWFMapEditForm.ShowAltitudeRadioGroupClick(Sender: TObject);
begin
  MainDrawGrid.DefaultRowHeight := MainDrawGrid.DefaultRowHeight;
end;

Procedure TWFMapEditForm.FormCreate(Sender: TObject);
Begin
  MapFile:=TMulFile.Create;
  FBrush:=TStringList.Create;
  loadSelectModes;
  createMenue('tileids.lst');
  loadTextureList('tileids.lst');
  loadBookMarks;
  loadBrushes;
  fillFirstClick := False;
  fillRect.Left := -1;
  fillRect.Top := -1;
  fillRect.Right := -1;
  fillRect.Bottom := -1;
  MapComboBoxSourceChange(Sender);
  MapComboBoxDestinationChange(Sender);
End;

Procedure TWFMapEditForm.FormDestroy(Sender: TObject);
Begin
 // FNamedTile.Free;
  FBrush.Free;
  MapFile.Free;
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.MapEditSourceChange(Sender: TObject);
Begin
  If FileExists(MapEditSource.Text) Then
    Case FileSize(MapEditSource.Text) of
      Map0_Britannia_MapSize: MapComboBoxSource.ItemIndex:=Map0_Britannia;
      Map2_Illshenar_MapSize: MapComboBoxSource.ItemIndex:=Map2_Illshenar;
      Map3_Malas_MapSize:     MapComboBoxSource.ItemIndex:=Map3_Malas;
    End;

  MapComboBoxSourceChange(Sender);
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.MapEditDestinationChange(Sender: TObject);
Begin
  If FileExists(MapEditDestination.Text) Then
    Case FileSize(MapEditDestination.Text) of
      Map0_Britannia_MapSize: MapComboBoxDestination.ItemIndex:=Map0_Britannia;
      Map2_Illshenar_MapSize: MapComboBoxDestination.ItemIndex:=Map2_Illshenar;
      Map3_Malas_MapSize:     MapComboBoxDestination.ItemIndex:=Map3_Malas;
    End;

  MapComboBoxDestinationChange(Sender);
End;

// 2004/07/05 - Shinigami: New
Procedure TWFMapEditForm.MapComboBoxSourceChange(Sender: TObject);
Begin
  Case MapComboBoxSource.ItemIndex of
    Map0_Britannia: Begin
                      MaxXSource:=Map0_Britannia_MaxX;MaxYSource:=Map0_Britannia_MaxY;MapSizeSource:=Map0_Britannia_MapSize;
                    End;
    Map2_Illshenar: Begin
                      MaxXSource:=Map2_Illshenar_MaxX;MaxYSource:=Map2_Illshenar_MaxY;MapSizeSource:=Map2_Illshenar_MapSize;
                    End;
    Map3_Malas:     Begin
                      MaxXSource:=Map3_Malas_MaxX;MaxYSource:=Map3_Malas_MaxY;MapSizeSource:=Map3_Malas_MapSize;
                    End;
    Else            Begin
                      MaxXSource:=Map0_Britannia_MaxX;MaxYSource:=Map0_Britannia_MaxY;MapSizeSource:=Map0_Britannia_MapSize;
                    End;
  End;

  CheckMapCopyParams(Sender);
End;

// 2004/07/05 - Shinigami: New
Procedure TWFMapEditForm.MapComboBoxDestinationChange(Sender: TObject);
Begin
  Case MapComboBoxDestination.ItemIndex of
    Map0_Britannia: Begin
                      MaxXDestination:=Map0_Britannia_MaxX;MaxYDestination:=Map0_Britannia_MaxY;MapSizeDestination:=Map0_Britannia_MapSize;
                    End;
    Map2_Illshenar: Begin
                      MaxXDestination:=Map2_Illshenar_MaxX;MaxYDestination:=Map2_Illshenar_MaxY;MapSizeDestination:=Map2_Illshenar_MapSize;
                    End;
    Map3_Malas:     Begin
                      MaxXDestination:=Map3_Malas_MaxX;MaxYDestination:=Map3_Malas_MaxY;MapSizeDestination:=Map3_Malas_MapSize;
                    End;
    Else            Begin
                      MaxXDestination:=Map0_Britannia_MaxX;MaxYDestination:=Map0_Britannia_MaxY;MapSizeDestination:=Map0_Britannia_MapSize;
                    End;
  End;

  CheckMapCopyParams(Sender);
End;

// 2004/07/05 - Shinigami: New
Procedure TWFMapEditForm.CheckMapCopyParams(Sender: TObject);
Var Enabled: Boolean;
Begin
  If FileExists(MapEditSource.Text) And (FileSize(MapEditSource.Text)=MapSizeSource) Then
    MapEditSource.Color:=clGreen Else MapEditSource.Color:=clRed;
  If FileExists(MapEditDestination.Text) And (FileSize(MapEditDestination.Text)=MapSizeDestination) Then
    MapEditDestination.Color:=clGreen Else MapEditDestination.Color:=clRed;

  Enabled:=(MapEditSource.Color=clGreen) And (MapEditDestination.Color=clGreen);
  SX1Edit.Enabled:=Enabled;SY1Edit.Enabled:=Enabled;SX2Edit.Enabled:=Enabled;SY2Edit.Enabled:=Enabled;
  DX1Edit.Enabled:=Enabled;DY1Edit.Enabled:=Enabled;DX2Edit.Enabled:=Enabled;DY2Edit.Enabled:=Enabled;
  SX1UpDown.Enabled:=Enabled;SY1UpDown.Enabled:=Enabled;SX2UpDown.Enabled:=Enabled;SY2UpDown.Enabled:=Enabled;
  DX1UpDown.Enabled:=Enabled;DY1UpDown.Enabled:=Enabled;CopyMapButton.Enabled:=Enabled;

  If Enabled Then Begin
    SX1UpDown.Max:=MaxXSource;SY1UpDown.Max:=MaxYSource;SX2UpDown.Max:=MaxXSource;SY2UpDown.Max:=MaxYSource;
    SX1EditExit(Sender);SX1EditChange(Sender);SY1EditExit(Sender);SY1EditChange(Sender);
    SX2EditExit(Sender);SX2EditChange(Sender);SY2EditExit(Sender);SY2EditChange(Sender);
  End;
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.SX1EditChange(Sender: TObject);
Var Wert: Integer;
Begin
  If TryStrToInt(SX1Edit.Text, Wert) Then Begin
    If Wert>SX1UpDown.Max Then Wert:=SX1UpDown.Max;
    If Wert<SX1UpDown.Min Then Wert:=SX1UpDown.Min;
    SX2UpDown.Min:=Wert;SX2EditExit(Sender);SX2EditChange(Sender);
    DX1UpDown.Max:=MaxXDestination-(StrToInt(SX2Edit.Text)-Wert+1);DX1EditExit(Sender);DX1EditChange(Sender);
  End;
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.SX1EditExit(Sender: TObject);
Var Wert: Integer;
Begin
  If Not TryStrToInt(SX1Edit.Text, Wert) Then Wert:=SX1UpDown.Min-1;
  If Wert>SX1UpDown.Max Then SX1Edit.Text:=IntToStr(SX1UpDown.Max);
  If Wert<SX1UpDown.Min Then SX1Edit.Text:=IntToStr(SX1UpDown.Min);
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.SY1EditChange(Sender: TObject);
Var Wert: Integer;
Begin
  If TryStrToInt(SY1Edit.Text, Wert) Then Begin
    If Wert>SY1UpDown.Max Then Wert:=SY1UpDown.Max;
    If Wert<SY1UpDown.Min Then Wert:=SY1UpDown.Min;
    SY2UpDown.Min:=Wert;SY2EditExit(Sender);SY2EditChange(Sender);
    DY1UpDown.Max:=MaxYDestination-(StrToInt(SY2Edit.Text)-Wert+1);DY1EditExit(Sender);DY1EditChange(Sender);
  End;
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.SY1EditExit(Sender: TObject);
Var Wert: Integer;
Begin
  If Not TryStrToInt(SY1Edit.Text, Wert) Then Wert:=SY1UpDown.Min-1;
  If Wert>SY1UpDown.Max Then SY1Edit.Text:=IntToStr(SY1UpDown.Max);
  If Wert<SY1UpDown.Min Then SY1Edit.Text:=IntToStr(SY1UpDown.Min);
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.SX2EditChange(Sender: TObject);
Var Wert: Integer;
Begin
  If TryStrToInt(SX2Edit.Text, Wert) Then Begin
    If Wert>SX2UpDown.Max Then Wert:=SX2UpDown.Max;
    If Wert<SX2UpDown.Min Then Wert:=SX2UpDown.Min;
    DX1UpDown.Max:=MaxXDestination-(Wert-StrToInt(SX1Edit.Text)+1);DX1EditExit(Sender);DX1EditChange(Sender);
  End;
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.SX2EditExit(Sender: TObject);
Var Wert: Integer;
Begin
  If Not TryStrToInt(SX2Edit.Text, Wert) Then Wert:=SX2UpDown.Min-1;
  If Wert>SX2UpDown.Max Then SX2Edit.Text:=IntToStr(SX2UpDown.Max);
  If Wert<SX2UpDown.Min Then SX2Edit.Text:=IntToStr(SX2UpDown.Min);
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.SY2EditChange(Sender: TObject);
Var Wert: Integer;
Begin
  If TryStrToInt(SY2Edit.Text, Wert) Then Begin
    If Wert>SY2UpDown.Max Then Wert:=SY2UpDown.Max;
    If Wert<SY2UpDown.Min Then Wert:=SY2UpDown.Min;
    DY1UpDown.Max:=MaxYDestination-(Wert-StrToInt(SY1Edit.Text)+1);DY1EditExit(Sender);DY1EditChange(Sender);
  End;
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.SY2EditExit(Sender: TObject);
Var Wert: Integer;
Begin
  If Not TryStrToInt(SY2Edit.Text, Wert) Then Wert:=SY2UpDown.Min-1;
  If Wert>SY2UpDown.Max Then SY2Edit.Text:=IntToStr(SY2UpDown.Max);
  If Wert<SY2UpDown.Min Then SY2Edit.Text:=IntToStr(SY2UpDown.Min);
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.DX1EditChange(Sender: TObject);
Var Wert: Integer;
Begin
  If TryStrToInt(DX1Edit.Text, Wert) Then Begin
    If Wert>DX1UpDown.Max Then Wert:=DX1UpDown.Max;
    If Wert<DX1UpDown.Min Then Wert:=DX1UpDown.Min;
    DX2Edit.Text:=IntToStr(Wert+StrToInt(SX2Edit.Text)-StrToInt(SX1Edit.Text));
  End;
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.DX1EditExit(Sender: TObject);
Var Wert: Integer;
Begin
  If Not TryStrToInt(DX1Edit.Text, Wert) Then Wert:=DX1UpDown.Min-1;
  If Wert>DX1UpDown.Max Then DX1Edit.Text:=IntToStr(DX1UpDown.Max);
  If Wert<DX1UpDown.Min Then DX1Edit.Text:=IntToStr(DX1UpDown.Min);
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.DY1EditChange(Sender: TObject);
Var Wert: Integer;
Begin
  If TryStrToInt(DY1Edit.Text, Wert) Then Begin
    If Wert>DY1UpDown.Max Then Wert:=DY1UpDown.Max;
    If Wert<DY1UpDown.Min Then Wert:=DY1UpDown.Min;
    DY2Edit.Text:=IntToStr(Wert+StrToInt(SY2Edit.Text)-StrToInt(SY1Edit.Text));
  End;
End;

// 2004/07/05 Shinigami: New
Procedure TWFMapEditForm.DY1EditExit(Sender: TObject);
Var Wert: Integer;
Begin
  If Not TryStrToInt(DY1Edit.Text, Wert) Then Wert:=DY1UpDown.Min-1;
  If Wert>DY1UpDown.Max Then DY1Edit.Text:=IntToStr(DY1UpDown.Max);
  If Wert<DY1UpDown.Min Then DY1Edit.Text:=IntToStr(DY1UpDown.Min);
End;

// 2004/07/02 Shinigami: ReWrite (was buggy)
Procedure TWFMapEditForm.CopyMapButtonClick(Sender: TObject);
Var MapFileSource, MapFileDestination : TMulFile;
    MapCell                           : TMapCell;
    SIndexX, SIndexY, DIndexX, DIndexY: Integer;
    SEndX, SEndY, ModX, ModY          : Integer;
    SIndexYTemp, SDeltaX              : Integer;
    SBasisX, SBasisY, DBasisX, DBasisY: Integer;
    XBlockS, YBlockS, XBlockD, YBlockD: Integer;
    XOffS, YOffS, XOffD, YOffD        : Integer;
    OldCaption                        : String;
Begin
  OldCaption:=CopyMapButton.Caption;
  CopyMapButton.Caption:='Working ....';CopyMapButton.Enabled:=False;

  MapFileSource:=nil;MapFileDestination:=nil;
  Try
    If MapEditSource.Text<>MapEdit.Text Then Begin
      MapFileSource:=TMulFile.Create;
      MapFileSource.Open(MapEditSource.Text);
    End Else MapFileSource:=MapFile;
    If MapEditDestination.Text<>MapEdit.Text Then Begin
      If MapEditDestination.Text<>MapEditSource.Text Then Begin
        MapFileDestination:=TMulFile.Create;
        MapFileDestination.Open(MapEditDestination.Text);
      End Else MapFileDestination:=MapFileSource;
    End Else MapFileDestination:=MapFile;

    If StrToInt(SX1Edit.Text)<StrToInt(SX2Edit.Text) Then Begin
      SIndexX:=StrToInt(SX2Edit.Text);SEndX:=StrToInt(SX1Edit.Text)-1;ModX:=-1;
    End Else Begin
      SIndexX:=StrToInt(SX1Edit.Text);SEndX:=StrToInt(SX2Edit.Text)+1;ModX:=1;
    End;
    SDeltaX:=StrToInt(SX2Edit.Text)-StrToInt(SX1Edit.Text)+1;
    If StrToInt(SY1Edit.Text)<StrToInt(SY2Edit.Text) Then Begin
      SIndexYTemp:=StrToInt(SY2Edit.Text);SEndY:=StrToInt(SY1Edit.Text)-1;ModY:=-1;
    End Else Begin
      SIndexYTemp:=StrToInt(SY1Edit.Text);SEndY:=StrToInt(SY2Edit.Text)+1;ModY:=1;
    End;
    SBasisX:=StrToInt(SX1Edit.Text);SBasisY:=StrToInt(SY1Edit.Text);
    DBasisX:=StrToInt(DX1Edit.Text);DBasisY:=StrToInt(DY1Edit.Text);

    ProgressBar.Position:=0;
    Repeat
      DIndexX:=DBasisX+(SIndexX-SBasisX);SIndexY:=SIndexYTemp;

      Repeat
        DIndexY:=DBasisY+(SIndexY-SBasisY);

        XBlockS:=SIndexX Div 8;XOffS:=SIndexX Mod 8;
        YBlockS:=SIndexY Div 8;YOffS:=SIndexY Mod 8;
        XBlockD:=DIndexX Div 8;XOffD:=DIndexX Mod 8;
        YBlockD:=DIndexY Div 8;YOffD:=DIndexY Mod 8;

        MapFileSource.Read(MapEditSource.Text, (XBlockS*MainForm.MapHeight+YBlockS)*
          SizeOf(TMapBlock)+4+(YOffS*8+XOffS)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
        MapFileDestination.Write(MapEditDestination.Text, (XBlockD*MainForm.MapHeight+YBlockD)*
          SizeOf(TMapBlock)+4+(YOffD*8+XOffD)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));

        If ModX=1 Then ProgressBar.Position:=99-((SEndX-SIndexX+1)*100) Div SDeltaX Else
          ProgressBar.Position:=99-((SIndexX-SEndX+1)*100) Div SDeltaX;

        SIndexY:=SIndexY+ModY;
      Until (SIndexY=SEndY);

      SIndexX:=SIndexX+ModX;
    Until (SIndexX=SEndX);
    ProgressBar.Position:=100;
  Finally
    If (MapEditDestination.Text<>MapEdit.Text) And (MapEditDestination.Text<>MapEditSource.Text) Then MapFileDestination.Free;
    If MapEditSource.Text<>MapEdit.Text Then MapFileSource.Free;
  End;

  CopyMapButton.Caption:=OldCaption;CopyMapButton.Enabled:=True;
  If MapEdit.Text=MapEditDestination.Text Then MainDrawGrid.Invalidate;

  SX1Edit.Text:='0';SY1Edit.Text:='0';SX2Edit.Text:='0';SY2Edit.Text:='0'; // Finished
  DX1Edit.Text:='0';DY1Edit.Text:='0';
  ProgressBar.Position:=0;
End;

procedure TWFMapEditForm.GridBoxClick(Sender: TObject);
begin
    case GridBox.ItemIndex of
      0: MainDrawGrid.GridLineWidth := 1;
      1: MainDrawGrid.GridLineWidth := 0;
    end;
     MainDrawGrid.DefaultRowHeight := MainDrawGrid.DefaultRowHeight;
end;

procedure TWFMapEditForm.eXit1Click(Sender: TObject);
begin
  SaveFileNames(MapEdit.Text, UOPathEdit.Text);
	Close;
end;

procedure TWFMapEditForm.MapEditCloseBtnClick(Sender: TObject);
begin
  SaveFileNames(MapEdit.Text, UOPathEdit.Text);
	Close;
end;

procedure TWFMapEditForm.CoordGoBtnClick(Sender: TObject);
var
  temp: TSelectCellEvent;
  x, y: integer;
begin
  SaveFileNames(MapEdit.Text, UOPathEdit.Text);
  temp := MainDrawGrid.OnSelectCell; // Save the eventhandler
  MainDrawGrid.OnSelectCell := nil;
  try
    If Not TryStrToInt(XJumpEdit.Text, x) Then x:=0;
    if x < 0 then x := 0;
    if x > (MainDrawGrid.ColCount-1) then x := (MainDrawGrid.ColCount-1);

    If Not TryStrToInt(YJumpEdit.Text, y) Then x:=0;
    if y < 0 then y := 0;
    if y > (MainDrawGrid.RowCount-1) then y := (MainDrawGrid.RowCount-1);

    if MainDrawGrid.Col = x then MainDrawGrid.Col := abs(x-1);
    if MainDrawGrid.Row = y then MainDrawGrid.Row := abs(y-1);
    MainDrawGrid.Col := x;
    MainDrawGrid.Row := y;

    XJumpEdit.Text:=IntToStr(x);
    YJumpEdit.Text:=IntToStr(y);
  finally
    MainDrawGrid.OnSelectCell := temp; // Restore the eventhandler
  end;
end;

procedure TWFMapEditForm.ZoomInClick(Sender: TObject);
begin
	MainDrawGrid.DefaultRowHeight := MainDrawGrid.DefaultRowHeight + 5;
	MainDrawGrid.DefaultColWidth := MainDrawGrid.DefaultColWidth + 5;
end;

procedure TWFMapEditForm.ZoomOutClick(Sender: TObject);
begin
	MainDrawGrid.DefaultRowHeight := MainDrawGrid.DefaultRowHeight - 5;
	MainDrawGrid.DefaultColWidth := MainDrawGrid.DefaultColWidth - 5;
end;

// 2004/07/05 - Shinigami: use MouseLastCol, MouseLastRow
procedure TWFMapEditForm.MainDrawGridKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var
  index : integer;
begin
  case Key of
    vk_up:
    	begin
         	Key_Move := true;
            if MainDrawGrid.TopRow > 0 then
            	MainDrawGrid.TopRow := MainDrawGrid.TopRow -1;;
            MouseLastRow:=MainDrawGrid.Row;
            UpdateStatusBar;
         end;
    vk_down:
      	begin
         	Key_Move := true;
            if MainDrawGrid.TopRow < MainDrawGrid.ColCount then
            	MainDrawGrid.TopRow := MainDrawGrid.TopRow +1;
            MouseLastRow:=MainDrawGrid.Row;
            UpdateStatusBar;
         end;
    vk_left:
      	begin
         	Key_Move := true;
            if MainDrawGrid.LeftCol > 0 then
            	MainDrawGrid.LeftCol:= MainDrawGrid.LeftCol-1;
            MouseLastCol:=MainDrawGrid.Col;
            UpdateStatusBar;
         end;
     vk_right:
      	begin
         	Key_Move := true;
            if MainDrawGrid.LeftCol < MainDrawGrid.RowCount then
            	MainDrawGrid.LeftCol := MainDrawGrid.LeftCol +1;
            MouseLastCol:=MainDrawGrid.Col;
            UpdateStatusBar;
         end;
   end;
   if (ssAlt in Shift) and (ssCtrl in Shift) then
   begin
     case Key of
       48 : index := 0;
       49 : index := 1;
       50 : index := 2;
       51 : index := 3;
       52 : index := 4;
       53 : index := 5;
       54 : index := 6;
       55 : index := 7;
       56 : index := 8;
       57 : index := 9;
     else
       index:=0;
     end;
     if (Key >= 48) and (key <= 57) then
     begin
       BookMarks[index].Col := MainDrawGrid.Col;
       BookMarks[index].Row := MainDrawGrid.Row;
       BookMarks[index].isset := not BookMarks[index].isset;
     end;
     MainDrawGrid.Repaint;
   end;
   if (ssCtrl in Shift) then
   begin
     case Key of
       48 : index := 0;
       49 : index := 1;
       50 : index := 2;
       51 : index := 3;
       52 : index := 4;
       53 : index := 5;
       54 : index := 6;
       55 : index := 7;
       56 : index := 8;
       57 : index := 9;
     else
       index:=0;
     end;
     if (Key >= 48) and (key <= 57) and BookMarks[index].isset then
     begin
       XJumpEdit.Text := IntToStr(BookMarks[index].Col);
       YJumpEdit.Text := IntToStr(BookMarks[index].Row);
       CoordGoBtn.Click;
     end;
   end;
end;

procedure TWFMapEditForm.BrushSizeMoverClick(Sender: TObject;
  Button: TUDBtnType);
begin
  BrushSizeEdt.Text := IntToStr(BrushSizeMover.Position);
end;

procedure TWFMapEditForm.BitBtn3Click(Sender: TObject);
var
   {col,row,count,}i{,x,j}:integer;
   _file:textfile;
   MapCell: TMapCell;
   XBlock, YBlock, XOff, YOff, TempI: integer;
   incom:string;
   x1,y1:integer;

   procedure do_move(_Col,_Row:Integer);
      begin
      	XBlock := _Col div 8;
         YBlock := _Row div 8;
         XOff := _Col mod 8;
         YOff := _Row mod 8;
        // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
        // BlockRead(MapFile, MapCell, SizeOf(TMapCell));
         MapFile.Read(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
           SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
         if SelectDrawingModeComboBox.ItemIndex = Ord(selected) then
         	MapCell.TileID := TextureDrawGrid.Tag;
         if SelectDrawingModeComboBox.ItemIndex >= Ord(dynamic_start) then
         	MapCell.TileID := GetNamedTile(SelectDrawingModeComboBox.Text);
         TempI := MapCell.Altitude;
         case AltitudeRadioGroup.ItemIndex of
         	0: Inc(TempI, StrToInt(ZValueEdit.Text));
            1: Dec(TempI, StrToInt(ZValueEdit.Text));
            2: TempI := StrToInt(ZValueEdit.Text);
         end;
         if TempI > 127 then
         	TempI := 127
         else
         	if TempI < -128 then
            	TempI := -128;
         MapCell.Altitude := TempI;
        // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
        // BlockWrite(MapFile, MapCell, SizeOf(TMapCell));
         MapFile.Write(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
           SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
         MainDrawGridDrawCell(Sender, _Col, _Row, MainDrawGrid.CellRect(_Col, _Row), []);
      end;


var
   mike:string;

begin
	assignfile(_file,'d:\maps\dung12.map');
   reset(_file);
  // x1:=50;
   y1:=50;
   while not eof(_file) do
   	begin
			readln(_file,incom);
         x1:=50;
         for i:=1 to length(incom) do
         	begin
            	inc(x1,4);
            	mike:=incom[i];
               case mike[1] of
            		#176:
                  	begin
do_move(x1,y1);
do_move(x1+1,y1);
do_move(x1+2,y1);
do_move(x1+3,y1);
do_move(x1,y1+1);
do_move(x1+1,y1+1);
do_move(x1+2,y1+1);
do_move(x1+3,y1+1);
do_move(x1,y1+2);
do_move(x1+1,y1+2);
do_move(x1+2,y1+2);
do_move(x1+3,y1+2);
do_move(x1,y1+3);
do_move(x1+1,y1+3);
do_move(x1+2,y1+3);
do_move(x1+3,y1+3);


                     end;
               end;
            end;
         inc(Y1,4);
      end;
  // do_move(Col,Row); // Werte nicht initialisiert, also lieber ausblenden (Shinigami)
   closefile(_File);
end;

procedure TWFMapEditForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i : integer;
  bookList : TStringList;
begin
 (*	{$I-} CloseFile(MapFile); {$I+} *)
  bookList := TStringList.Create;
  bookList.Add('<?xml version="1.0" ?>');
  bookList.Add('<BookmarkList>');
  for i := 0 to 9 do
  begin
    bookList.Add('  <Bookmark id="'+IntToStr(i)+'">');
    bookList.Add('    <Col id="'+IntToStr(i)+'">'+IntToStr(BookMarks[i].Col)+'</Col>');
    bookList.Add('    <Row id="'+IntToStr(i)+'">'+IntToStr(BookMarks[i].Row)+'</Row>');
    bookList.Add('    <Enabled id="'+IntToStr(i)+'">'+BoolToStr(BookMarks[i].isset, True)+'</Enabled>');
    bookList.Add('  </Bookmark>');
  end;
  bookList.Add('</BookmarkList>');
  bookList.SaveToFile(MainForm.Appath+'bookmarklist.xml');
  bookList.Free;
 // FNamedTile.Free; -> FormDestroy by Shinigami
 // FBrush.Free;     -> FormDestroy by Shinigami
end;

procedure TWFMapEditForm.ShowTextureID1Click(Sender: TObject);
begin
  ShowTextureID1.Checked := NOT ShowTextureID1.Checked;
  TextureDrawGrid.Repaint;
end;

procedure TWFMapEditForm.HideunusedTexture1Click(Sender: TObject);
begin
  HideunusedTexture1.Checked := NOT HideunusedTexture1.Checked;
  TextureDrawGrid.Repaint;
end;

procedure TWFMapEditForm.SpeedButton4Click(Sender: TObject);
begin
  WFWorldViewForm.Show;
end;

procedure TWFMapEditForm.udRValueClick(Sender: TObject; Button: TUDBtnType);
begin
  edRauschen.Text := IntToStr(udRValue.Position);
end;

procedure TWFMapEditForm.coloredAltitudeClick(Sender: TObject);
begin
  coloredAltitude.Checked := not coloredAltitude.Checked;
  MainDrawGrid.Repaint;
end;

procedure TWFMapEditForm.ShowonlyColor1Click(Sender: TObject);
begin
  ShowonlyColor1.Checked := not ShowonlyColor1.Checked;
  MainDrawGrid.Repaint;
end;

procedure TWFMapEditForm.ShowAltitude1Click(Sender: TObject);
begin
  ShowAltitude1.Checked := not ShowAltitude1.Checked;
  MainDrawGrid.Repaint;
end;

procedure TWFMapEditForm.MainDrawGridMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  MapCell: TMapCell;
  iRow, iCol, i : Integer;
  XBlock, YBlock, XOff, YOff: integer;
  rRect : TRect;
begin
  if Button = mbRight then
  begin
    MainDrawGrid.MouseToCell(X,Y,iCol,iRow);
    XBlock := iCol div 8;
    YBlock := iRow div 8;
    XOff := iCol mod 8;
    YOff := iRow mod 8;

    if FileNamesCorrect then
    begin
     // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
     // BlockRead(MapFile, MapCell, SizeOf(TMapCell));
      MapFile.Read(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
        SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
    end;
    if cbSortet.Checked then
    begin
      i := findRow(MapCell.TileID);
      if i > -1 then
      begin
        SortedTextureGrid.Repaint;
        TextureDrawGrid.Tag := MapCell.TileID;
        SortedTextureGrid.TopRow := i;
        SortedTextureGrid.Canvas.Pen.Color := clRed;
        SortedTextureGrid.Canvas.Brush.Style := bsClear;
        rRect := SortedTextureGrid.CellRect(0, i);
        SortedTextureGrid.Canvas.Rectangle(rRect);
      end;
    end
    else
    begin
      TextureDrawGrid.Repaint;
      TextureDrawGrid.Tag := MapCell.TileID;
      TextureDrawGrid.TopRow := MapCell.TileID;
      TextureDrawGrid.Canvas.Pen.Color := clRed;
      TextureDrawGrid.Canvas.Brush.Style := bsClear;
      rRect := TextureDrawGrid.CellRect(0, MapCell.TileID);
      TextureDrawGrid.Canvas.Rectangle(rRect);
    end;
    UpdateStatusBar;
  end;
end;

procedure TWFMapEditForm.btnFindClick(Sender: TObject);
var
  index : integer;
  rRect : TRect;
begin
  if edFindID.Text <> '' then
    if cbSortet.Checked then
    begin
      index := FindRow(StrToInt('$'+edFindID.Text));
      if index > -1 then
      begin
        SortedTextureGrid.Repaint;
        TextureDrawGrid.Tag := StrToInt('$'+edFindID.Text);
        SortedTextureGrid.TopRow := index;
        SortedTextureGrid.Canvas.Pen.Color := clRed;
        SortedTextureGrid.Canvas.Brush.Style := bsClear;
        rRect := SortedTextureGrid.CellRect(0, index);
        SortedTextureGrid.Canvas.Rectangle(rRect);
      end;
    end
    else
    begin
      index := StrToInt('$'+edFindID.Text);
      TextureDrawGrid.Repaint;
      TextureDrawGrid.Tag := index;
      TextureDrawGrid.TopRow := index;
      TextureDrawGrid.Canvas.Pen.Color := clRed;
      TextureDrawGrid.Canvas.Brush.Style := bsClear;
      rRect := TextureDrawGrid.CellRect(0, index);
      TextureDrawGrid.Canvas.Rectangle(rRect);
    end;
end;

procedure TWFMapEditForm.SortedTextureGridClick(Sender: TObject);
var
  id : integer;
begin
  SelectDrawingModeComboBox.ItemIndex := Ord(selected);
  id := StrToInt('$'+copy(SortedTextureGrid.Rows[SortedTextureGrid.Row].Text,0,4));
  TextureDrawGrid.Tag := Id;
  UpdateStatusBar;
end;

procedure TWFMapEditForm.SortedTextureGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  Bitmap: TBitmap;
  id : integer;
begin
  Bitmap := TBitmap.Create;
  Bitmap.Width := 1; // LoadXYZ sets them
  Bitmap.Height := 1;
  Bitmap.PixelFormat := pf15bit;
  //SortedTextureGrid.
  id := StrToInt('$'+copy(SortedTextureGrid.Rows[ARow].Text,0,4));
  if not LoadTexture(id, Bitmap) then
    if not LoadArt(id, Bitmap) then
    begin
    end;
  SortedTextureGrid.Canvas.StretchDraw(Rect, Bitmap);
  if gdSelected	in State then
  begin
    SortedTextureGrid.Canvas.Pen.Color := clRed;
    SortedTextureGrid.Canvas.Brush.Style := bsClear;
    SortedTextureGrid.Canvas.Rectangle(Rect);
  end;
  SortedTextureGrid.Canvas.Brush.Style := bsSolid;
  SortedTextureGrid.Canvas.Brush.Color := clWhite; // default
  if ShowTextureID1.Checked then
    SortedTextureGrid.Canvas.TextOut(Rect.Left+1, Rect.Top+1, ' '+IntToSpacedHex(id, 2)+' ');
  Bitmap.Free;
end;

procedure TWFMapEditForm.cbSortetClick(Sender: TObject);
begin
  SortedTextureGrid.Visible := cbSortet.Checked;
end;

procedure TWFMapEditForm.Options1Click(Sender: TObject);
var
  newXML, tileList : TStringList;
  i, j : integer;
  astring : String;
begin
  WFFOptions := TWFFOptions.Create(Application);
  if WFFOptions.ShowModal = mrOk then
  begin
    // neue XML erzeugen
    newXML := TStringList.Create;
    tileList := TStringList.Create;
    newXML.Add('<?xml version="1.0" ?>');
    newXML.Add('<TileList>');
    for i := 0 to WFFOptions.lvSelectModes.Items.Count -1 do
    begin
      newXML.Add('  <Tile id="'+IntToStr(i)+'">');
      newXML.Add('    <Name id="'+IntToStr(i)+'">'+WFFOptions.lvSelectModes.Items.Item[i].Caption+'</Name>');
      astring := WFFOptions.lvSelectModes.Items.Item[i].SubItems.Text;
      tileList.Clear;
      tileList := TextToStringList(',',astring);
      for j := 0 to tileList.Count-1 do
      begin
        newXML.Add('    <TileId id="'+IntToStr(j)+'">'+tileList[j]+'</TileId>');
      end;
      newXML.Add('  </Tile>');
    end;
    newXML.Add('</TileList>');
    newXML.SaveToFile(MainForm.Appath+'tilelist.xml');
    newXML.Free;
    loadSelectModes;
    // Texturen schreiben!
    tileList.Clear;
    for i := 0 to WFFOptions.lbTexture.Count -1 do
      tileList.Add('textureid='+WFFOptions.lbTexture.Items[i]);
    tileList.SaveToFile(MainForm.Appath+'Textures\'+WFFOptions.cbTextureLists.Text);
    loadTextureList(WFFOptions.cbTextureLists.Text);
    createMenue(WFFOptions.cbTextureLists.Text);
    tileList.Free;
  end;
end;

procedure TWFMapEditForm.btnCustomTexturesClick(Sender: TObject);
begin
  pmCustomTextures.Popup(btnCustomTextures.ClientOrigin.X+13,btnCustomTextures.ClientOrigin.Y);
end;

procedure TWFMapEditForm.oText1Click(Sender: TObject);
{var
  x,y,c : Integer;
  FileHandle: Integer;
  StringLen: Integer;
  inhalt : TStringList;
  MapCell: TMapCell;
  XBlock, YBlock, XOff, YOff: integer;
  astring : String; }
begin
  //inhalt := TStringList.Create;
  {c := 0;
  if saveExport.Execute then
  begin
    FileHandle := FileCreate(saveExport.FileName);
    for x := 0 to MainForm.MapWidth*8 do
      for y := 0 to MainForm.MapHeight*8 do
      begin
        XBlock := X div 8;
        YBlock := Y div 8;
        XOff := X mod 8;
        YOff := Y mod 8;
        if FileNamesCorrect then
        begin
         // Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell));
         // BlockRead(MapFile, MapCell, SizeOf(TMapCell));
          MapFile.Read(WFMapEditForm.MapEdit.Text, (XBlock*MainForm.MapHeight+YBlock)*
            SizeOf(TMapBlock)+4+(YOff*8+XOff)*SizeOf(TMapCell), MapCell, SizeOf(TMapCell));
          astring := 'Block (X,Y,Z):'+IntToStr(x)+','+IntToStr(x)+','+IntToStr(MapCell.Altitude)
                    +'Tile ID (Dez,Hex):'+IntToStr(MapCell.TileID)+',$'+IntToHex(MapCell.TileID,4);
          FileWrite(FileHandle, astring, length(astring));
          //inhalt.Add(astring);
        end;
      end;
      FileClose(FileHandle);

    //inhalt.SaveToFile(saveExport.FileName);
  end;
  //inhalt.Free;  }
end;

procedure TWFMapEditForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  index : integer;
begin
  if (ssCtrl in Shift) then
  begin
    case Key of
      48 : index := 0;
      49 : index := 1;
      50 : index := 2;
      51 : index := 3;
      52 : index := 4;
      53 : index := 5;
      54 : index := 6;
      55 : index := 7;
      56 : index := 8;
      57 : index := 9;
    else
      index:=0;
    end;
    if (Key >= 48) and (key <= 57) and BookMarks[index].isset then
    begin
      XJumpEdit.Text := IntToStr(BookMarks[index].Col);
      YJumpEdit.Text := IntToStr(BookMarks[index].Row);
      CoordGoBtn.Click;
    end;
  end;
end;

// 2004/07/06 Shinigami - BrushesEdit will show choosen Brush
// 2004/07/06 Shinigami - Brushes DropDownBox will show up to 25 entries now
Procedure TWFMapEditForm.CustomBrushesEditClick(Sender: TObject);
Begin
  WFCustomBrush:=TWFCustomBrush.Create(Application);
  WFCustomBrush.cbCustomBrushes.Items.Assign(cbCustomBrushes.Items);
  WFCustomBrush.cbCustomBrushes.ItemIndex:=cbCustomBrushes.ItemIndex; // Shinigami
  WFCustomBrush.cbCustomBrushes.DropDownCount:=cbCustomBrushes.DropDownCount; // Shinigami
  If WFCustomBrush.ShowModal=mrOK Then loadBrushes;
End;

procedure TWFMapEditForm.cbCustomBrushesChange(Sender: TObject);
begin
  LoadBrush(cbCustomBrushes.Text);
end;

// Shinigami - 2004/05/21
Constructor TMulFile.Create;
Begin
  Inherited Create;
  FStream:=nil;FName:='';FOpened:=False;
End;

// Shinigami - 2004/05/21
Destructor TMulFile.Destroy;
Begin
  Close;
  Inherited Destroy;
End;

// Shinigami - 2004/05/21
// Shinigami - 2004/07/02: Vor dem ffnen wird geschaut, ob die Datei berhaupt existiert... erspart Exceptions
Function TMulFile.Open(Const AName: String): Boolean;
Begin
  Result:=True;

  If FName=AName Then Begin
    If Not FOpened Then Begin
      Try
        If FileExists(FName) Then Begin
          FStream:=TFileStream.Create(FName, fmOpenReadWrite Or fmShareDenyWrite);
          FOpened:=True;
        End Else Result:=False;
      Except
        Result:=False;
      End;
    End;
  End Else Begin
    Close;

    Try
      If FileExists(AName) Then Begin
        FStream:=TFileStream.Create(AName, fmOpenReadWrite Or fmShareDenyWrite);
        FName:=AName;FOpened:=True;
      End Else Result:=False;
    Except
      Result:=False;
    End;
  End;
End;

// Shinigami - 2004/05/21
Procedure TMulFile.Close;
Begin
  If FOpened Then Begin
    FStream.Free;
    FStream:=nil;FName:='';FOpened:=False;
  End;
End;

// Shinigami - 2004/05/21
Function TMulFile.Read(Const AName: String; Const AOffset: LongInt; Var ABuffer; Const ACount: Longint): Longint;
Begin
  If Open(AName) Then Begin
    Try
      FStream.Seek(AOffset, soFromBeginning);
      Result:=FStream.Read(ABuffer, ACount);
    Except
      Result:=0;
    End;
  End Else Result:=0;
End;

// Shinigami - 2004/05/21
Function TMulFile.Write(Const AName: String; Const AOffset: LongInt; Var ABuffer; Const ACount: Longint): Longint;
Begin
  If Open(AName) Then Begin
    Try
      FStream.Seek(AOffset, soFromBeginning);
      Result:=FStream.Write(ABuffer, ACount);
    Except
      Result:=0;
    End;
  End Else Result:=0;
End;

End.
